{*------------------------------------------------------------------------------
  C Typen Deklaration (bersetztung der Variabeln von C in Delphi)
  @Author    nitschchedu
  @Version   1 Alpha
  @Todo      C Typen Convertation
-------------------------------------------------------------------------------}

unit nduCType;

interface

uses
  Windows, Classes;

type
  //*** bersetztung der Variabeln von C in Delphi ***//
  //*** ------------------------------------------ ***//
  //C                 //Delphi        //Komentar
  //*** ------------------------------------------ ***//
  Bool = longbool;        ///C Bool
  Int = integer;        ///C Int
  unsigned_short = word;            ///C unsigned short
  ushort = word;            ///C ushort
  short = smallint;        ///C short
  signed_short = smallint;        ///C signed short
  UINT = cardinal;        ///C UINT
  DWORD = cardinal;        ///C DWORD
  unsigned_long = cardinal;        ///C unsigned short
  unsigned_long_int = cardinal;        ///C unsigned short int
  ulong = cardinal;        ///C ULong
  long = longint;        ///C Long
  signed_char = shortint;        ///C signed char
  unsigned_char = byte;            ///C unsigned char
  uchar = byte;            ///C UChar
  LPSTR = PChar;          ///C LPSTR
  PSTR = PChar;          ///C PSTR
  //C Void (Gibt es nicht in Delphi) (ist ne procedure)
  //void              = Pointer;
  PVOID = Pointer;        ///C PVoid
  PPVOID = ^PVOID;          ///C ppvoid
  float = single;          ///C float
  long_double = extended;        ///C long double
  wchar = widechar;        ///C WChar
  ulonglong = TLargeInteger;  ///C ulonglong
  LPCTSTR = PWideChar;      ///C LPCTSTR
  Handle = THandle;        ///C Handle
  LPByte = PByte;          ///C LPByte
  PLPCWSTR = ^LPCWSTR;        ///C PLPCWSTR
  PPByte = ^PByte;          ///C PPByte
  unsigned_int = cardinal;        ///C unsigned int
  Punsigned_int = ^unsigned_int;  ///C unsigned int *
  unsigned = cardinal;        ///C unsigned
  LPVOID = Pointer;        ///C LPVOID
  ULONG_PTR = longword;        ///C ULONG_PTR
  PTSTR = LPWSTR;          ///C PTSTR
  PPTSTR = ^PTSTR;          ///C PPTSTR
  int32 = longint;        ///C int32
  //*** ------------------------------------------ ***//
  //*** ------------------------------------------ ***//


  //*** ------------------------------------------ ***//
  //***  crtdefs.h                                   ***//
  Tndu_time32_t = long;            ///C time32_t aus der crtdefs.h
  Tndu_errno_t = integer;        ///C errno_t aus der crtdefs.h
  Tndu_size_t = int64;          ///C size_t aus der crtdefs.h
  //*** ------------------------------------------ ***//
  //*** ------------------------------------------ ***//




  _SecHandle = record
    dwLower: ULONG_PTR;
    dwUpper: ULONG_PTR;
  end;

  SecHandle = _SecHandle;
  PSecHandle = ^SecHandle;

implementation

end.
