{*------------------------------------------------------------------------------
  NTDDNdis Header bersetztung
  @Author    nitschchedu
  @Version   1.0 Alpha
  @Todo      C Header Convertation
-------------------------------------------------------------------------------}

{*------------------------------------------------------------------------------
/*++ BUILD Version: 0001        // Increment this if a change has global effects

Copyright (c) Microsoft Corporation. All rights reserved.

Module Name:

    ntddndis.h

Abstract:

    This is the include file that defines all constants and types for
    accessing the Network driver interface device.

Author:

    NDIS/ATM Development Team

Revision History:

    added the correct values for NDIS 3.0.
    added Pnp IoCTLs and structures
    added general co ndis oids.
    added PnP and PM OIDs.

--*/
-------------------------------------------------------------------------------}

unit nduNtDDNdis;

interface

uses
  nduCType, nduifdef, nduWinIoCtl, Windows;

function NDIS_CONTROL_CODE(request, method: integer): integer;

const
  NDU_DD_NDIS_DEVICE_NAME = '\\Device\\UNKNOWN';

//NDU_IOCTL_NDIS_QUERY_GLOBAL_STATS = NDIS_CONTROL_CODE(0, NDU_METHOD_OUT_DIRECT);

type
  Tndu_NDIS_OID = ulong;
  Pndu_NDIS_OID = ^Tndu_NDIS_OID;


  // IOCTL_NDIS_QUERY_ALL_STATS returns a sequence of these, packed
  // together.  This structure is unaligned because not all statistics
  // have a length that is a ULONG multiple.


  Tndu_NDIS_STATISTICS_VALUE = record
    Oid: Tndu_NDIS_OID;
    DataLength: ulong;
    Data: array[0..0] of uchar;      // variable length
  end;

  Pndu_PNDIS_STATISTICS_VALUE = ^Tndu_NDIS_STATISTICS_VALUE;

  Tndu_NDIS_STATISTICS_VALUE_EX = record
    Oid: Tndu_NDIS_OID;
    DataLength: ulong;            // the length of the OID data
    Length: ulong;
    // the length of this instance of NDIS_STATISTICS_VALUE_EX
    Data: array[0..0] of uchar;    // variable length
  end;

  Pndu_PNDIS_STATISTICS_VALUE_EX = ^Tndu_NDIS_STATISTICS_VALUE_EX;


  // Structure used to define a self-contained variable data structure

  Pndu_PNDIS_VAR_DATA_DESC = ^Tndu_NDIS_VAR_DATA_DESC;

  Tndu_NDIS_VAR_DATA_DESC = record
    Length: ushort;                // # of octects of data
    MaximumLength: ushort;        // # of octects available
    Offset: ULONG_PTR;            // Offset of data relative to the descriptor
  end;


// NDIS Object Types used in NDIS_OBJECT_HEADER

const
  NDU_NDIS_OBJECT_TYPE_DEFAULT = $80;
  // used when object type is implicit in the API call
  NDU_NDIS_OBJECT_TYPE_MINIPORT_INIT_PARAMETERS = $81;
  // used by NDIS in NDIS_MINIPORT_INIT_PARAMETERS
  NDU_NDIS_OBJECT_TYPE_SG_DMA_DESCRIPTION = $83;
  // used by miniport drivers in NDIS_SG_DMA_DESCRIPTION
  NDU_NDIS_OBJECT_TYPE_MINIPORT_INTERRUPT = $84;
  // used by miniport drivers in NDIS_MINIPORT_INTERRUPT_EX
  NDU_NDIS_OBJECT_TYPE_DEVICE_OBJECT_ATTRIBUTES = $85;
  // used by miniport or filter drivers in NDIS_DEVICE_OBJECT_ATTRIBUTES
  NDU_NDIS_OBJECT_TYPE_BIND_PARAMETERS = $86;
  // used by NDIS in NDIS_BIND_PARAMETERS
  NDU_NDIS_OBJECT_TYPE_OPEN_PARAMETERS = $87;
  // used by protocols in NDIS_OPEN_PARAMETERS
  NDU_NDIS_OBJECT_TYPE_RSS_CAPABILITIES = $88;
  // used by miniport in NDIS_RECEIVE_SCALE_CAPABILITIES
  NDU_NDIS_OBJECT_TYPE_RSS_PARAMETERS = $89;
  // used by miniport and protocol in NDIS_RECEIVE_SCALE_PARAMETERS
  NDU_NDIS_OBJECT_TYPE_MINIPORT_DRIVER_CHARACTERISTICS = $8A;
  NDU_NDIS_OBJECT_TYPE_FILTER_DRIVER_CHARACTERISTICS = $8B;
  NDU_NDIS_OBJECT_TYPE_FILTER_PARTIAL_CHARACTERISTICS = $8C;
  NDU_NDIS_OBJECT_TYPE_FILTER_ATTRIBUTES = $8D;
  NDU_NDIS_OBJECT_TYPE_CLIENT_CHIMNEY_OFFLOAD_GENERIC_CHARACTERISTICS = $8E;
  NDU_NDIS_OBJECT_TYPE_PROVIDER_CHIMNEY_OFFLOAD_GENERIC_CHARACTERISTICS = $8F;
  NDU_NDIS_OBJECT_TYPE_CO_PROTOCOL_CHARACTERISTICS = $90;
  NDU_NDIS_OBJECT_TYPE_CO_MINIPORT_CHARACTERISTICS = $91;
  NDU_NDIS_OBJECT_TYPE_MINIPORT_PNP_CHARACTERISTICS = $92;
  NDU_NDIS_OBJECT_TYPE_CLIENT_CHIMNEY_OFFLOAD_CHARACTERISTICS = $93;
  NDU_NDIS_OBJECT_TYPE_PROVIDER_CHIMNEY_OFFLOAD_CHARACTERISTICS = $94;
  NDU_NDIS_OBJECT_TYPE_PROTOCOL_DRIVER_CHARACTERISTICS = $95;
  NDU_NDIS_OBJECT_TYPE_REQUEST_EX = $96;
  NDU_NDIS_OBJECT_TYPE_OID_REQUEST = $96;
  NDU_NDIS_OBJECT_TYPE_TIMER_CHARACTERISTICS = $97;
  NDU_NDIS_OBJECT_TYPE_STATUS_INDICATION = $98;
  NDU_NDIS_OBJECT_TYPE_FILTER_ATTACH_PARAMETERS = $99;
  NDU_NDIS_OBJECT_TYPE_FILTER_PAUSE_PARAMETERS = $9A;
  NDU_NDIS_OBJECT_TYPE_FILTER_RESTART_PARAMETERS = $9B;
  NDU_NDIS_OBJECT_TYPE_PORT_CHARACTERISTICS = $9C;
  NDU_NDIS_OBJECT_TYPE_PORT_STATE = $9D;
  NDU_NDIS_OBJECT_TYPE_MINIPORT_ADAPTER_REGISTRATION_ATTRIBUTES = $9E;
  NDU_NDIS_OBJECT_TYPE_MINIPORT_ADAPTER_GENERAL_ATTRIBUTES = $9F;
  NDU_NDIS_OBJECT_TYPE_MINIPORT_ADAPTER_OFFLOAD_ATTRIBUTES = $A0;
  NDU_NDIS_OBJECT_TYPE_MINIPORT_ADAPTER_NATIVE_802_11_ATTRIBUTES = $A1;
  NDU_NDIS_OBJECT_TYPE_RESTART_GENERAL_ATTRIBUTES = $A2;
  NDU_NDIS_OBJECT_TYPE_PROTOCOL_RESTART_PARAMETERS = $A3;
  NDU_NDIS_OBJECT_TYPE_MINIPORT_ADD_DEVICE_REGISTRATION_ATTRIBUTES = $A4;
  NDU_NDIS_OBJECT_TYPE_CO_CALL_MANAGER_OPTIONAL_HANDLERS = $A5;
  NDU_NDIS_OBJECT_TYPE_CO_CLIENT_OPTIONAL_HANDLERS = $A6;
  NDU_NDIS_OBJECT_TYPE_OFFLOAD = $A7;
  NDU_NDIS_OBJECT_TYPE_OFFLOAD_ENCAPSULATION = $A8;
  NDU_NDIS_OBJECT_TYPE_CONFIGURATION_OBJECT = $A9;
  NDU_NDIS_OBJECT_TYPE_DRIVER_WRAPPER_OBJECT = $AA;
  NDU_NDIS_OBJECT_TYPE_RESERVED = $AB;
  NDU_NDIS_OBJECT_TYPE_NSI_NETWORK_RW_STRUCT = $AC;
  NDU_NDIS_OBJECT_TYPE_NSI_COMPARTMENT_RW_STRUCT = $AD;
  NDU_NDIS_OBJECT_TYPE_NSI_INTERFACE_PERSIST_RW_STRUCT = $AE;

type
  Pndu_NDIS_OBJECT_HEADER = ^Tndu_NDIS_OBJECT_HEADER;

  Tndu_NDIS_OBJECT_HEADER = record
    aType: uchar;
    Revision: uchar;
    Size: ushort;
  end;

const
  NDU_NDIS_OBJECT_REVISION_1 = 1;


  // flags for NDIS_STATISTICS_INFO->SupportedStatistics structure


  NDU_NDIS_STATISTICS_FLAGS_VALID_DIRECTED_FRAMES_RCV = $00000001;
  NDU_NDIS_STATISTICS_FLAGS_VALID_MULTICAST_FRAMES_RCV = $00000002;
  NDU_NDIS_STATISTICS_FLAGS_VALID_BROADCAST_FRAMES_RCV = $00000004;
  NDU_NDIS_STATISTICS_FLAGS_VALID_BYTES_RCV = $00000008;
  NDU_NDIS_STATISTICS_FLAGS_VALID_RCV_DISCARDS = $00000010;
  NDU_NDIS_STATISTICS_FLAGS_VALID_RCV_ERROR = $00000020;
  NDU_NDIS_STATISTICS_FLAGS_VALID_DIRECTED_FRAMES_XMIT = $00000040;
  NDU_NDIS_STATISTICS_FLAGS_VALID_MULTICAST_FRAMES_XMIT = $00000080;
  NDU_NDIS_STATISTICS_FLAGS_VALID_BROADCAST_FRAMES_XMIT = $00000100;
  NDU_NDIS_STATISTICS_FLAGS_VALID_BYTES_XMIT = $00000200;
  NDU_NDIS_STATISTICS_FLAGS_VALID_XMIT_ERROR = $00000400;
  NDU_NDIS_STATISTICS_FLAGS_VALID_XMIT_DISCARDS = $00008000;
  NDU_NDIS_STATISTICS_FLAGS_VALID_DIRECTED_BYTES_RCV = $00010000;
  NDU_NDIS_STATISTICS_FLAGS_VALID_MULTICAST_BYTES_RCV = $00020000;
  NDU_NDIS_STATISTICS_FLAGS_VALID_BROADCAST_BYTES_RCV = $00040000;
  NDU_NDIS_STATISTICS_FLAGS_VALID_DIRECTED_BYTES_XMIT = $00080000;
  NDU_NDIS_STATISTICS_FLAGS_VALID_MULTICAST_BYTES_XMIT = $00100000;
  NDU_NDIS_STATISTICS_FLAGS_VALID_BROADCAST_BYTES_XMIT = $00200000;

  NDU_NDIS_STATISTICS_INFO_REVISION_1 = 1;


// structure used in OID_GEN_STATISTICS

type
  Pndu_NDIS_STATISTICS_INFO = ^Tndu_NDIS_STATISTICS_INFO;

  Tndu_NDIS_STATISTICS_INFO = record
    Header: Tndu_NDIS_OBJECT_HEADER;
    SupportedStatistics: ulong;
    ifInDiscards: ulong64;
    // OID_GEN_RCV_ERROR + OID_GEN_RCV_NO_BUFFER = OID_GEN_RCV_DISCARDS
    ifInErrors: ulong64;            // OID_GEN_RCV_ERROR
    ifHCInOctets: ulong64;
    // OID_GEN_BYTES_RCV = OID_GEN_DIRECTED_BYTES_RCV + OID_GEN_MULTICAST_BYTES_RCV + OID_GEN_BROADCAST_BYTES_RCV
    ifHCInUcastPkts: ulong64;        // OID_GEN_DIRECTED_FRAMES_RCV
    ifHCInMulticastPkts: ulong64;   // OID_GEN_MULTICAST_FRAMES_RCV
    ifHCInBroadcastPkts: ulong64;    // OID_GEN_BROADCAST_FRAMES_RCV
    ifHCOutOctets: ulong64;
    // OID_GEN_BYTES_XMIT = OID_GEN_DIRECTED_BYTES_XMIT + OID_GEN_MULTICAST_BYTES_XMIT + OID_GEN_BROADCAST_BYTES_XMIT
    ifHCOutUcastPkts: ulong64;      // OID_GEN_DIRECTED_FRAMES_XMIT
    ifHCOutMulticastPkts: ulong64;  // OID_GEN_MULTICAST_FRAMES_XMIT
    ifHCOutBroadcastPkts: ulong64;  // OID_GEN_BROADCAST_FRAMES_XMIT
    ifOutErrors: ulong64;            // OID_GEN_XMIT_ERROR
    ifOutDiscards: ulong64;          // OID_GEN_XMIT_DISCARDS
    ifHCInUcastOctets: ulong64;      // OID_GEN_DIRECTED_BYTES_RCV
    ifHCInMulticastOctets: ulong64; // OID_GEN_MULTICAST_BYTES_RCV
    ifHCInBroadcastOctets: ulong64;  // OID_GEN_BROADCAST_BYTES_RCV
    ifHCOutUcastOctets: ulong64;    // OID_GEN_DIRECTED_BYTES_XMIT
    ifHCOutMulticastOctets: ulong64;// OID_GEN_MULTICAST_BYTES_XMIT
    ifHCOutBroadcastOctets: ulong64;// OID_GEN_BROADCAST_BYTES_XMIT
  end;

  Pndu_NDIS_INTERRUPT_MODERATION = ^Tndu_NDIS_INTERRUPT_MODERATION;
  Tndu_NDIS_INTERRUPT_MODERATION = (
    NdisInterruptModerationUnknown,
    NdisInterruptModerationNotSupported,
    NdisInterruptModerationEnabled,
    NdisInterruptModerationDisabled
    );


// Bits used in Flags parameter of NDIS_INTERRUPT_MODERATION_PARAMETERS structure:


const
  NDU_NDIS_INTERRUPT_MODERATION_CHANGE_NEEDS_RESET = $00000001;
  NDU_NDIS_INTERRUPT_MODERATION_CHANGE_NEEDS_REINITIALIZE = $00000002;

  NDU_NDIS_INTERRUPT_MODERATION_PARAMETERS_REVISION_1 = 1;


// structure used in OID_GEN_INTERRUPT_MODERATION


type
  Pndu_NDIS_INTERRUPT_MODERATION_PARAMETERS = ^Tndu_NDIS_INTERRUPT_MODERATION_PARAMETERS;

  Tndu_NDIS_INTERRUPT_MODERATION_PARAMETERS = record
    Header: Tndu_NDIS_OBJECT_HEADER;
    Flags: ulong;
    InterruptModeration: Tndu_NDIS_INTERRUPT_MODERATION;
  end;


// structure used in OID_GEN_TIMEOUT_DPC_REQUEST_CAPABILITIES


const
  NDU_NDIS_TIMEOUT_DPC_REQUEST_CAPABILITIES_REVISION_1 = 1;

type
  Pndu_NDIS_TIMEOUT_DPC_REQUEST_CAPABILITIES =
    ^Tndu_NDIS_TIMEOUT_DPC_REQUEST_CAPABILITIES;

  Tndu_NDIS_TIMEOUT_DPC_REQUEST_CAPABILITIES = record
    Header: Tndu_NDIS_OBJECT_HEADER;
    Flags: ulong;
    TimeoutArrayLength: ulong;
    TimeoutArray: array[0..0] of ulong;
  end;


// PCI custom properties. used in OID_GEN_PCI_DEVICE_CUSTOM_PROPERTIES


const
  NDU_NDIS_OBJECT_TYPE_PCI_DEVICE_CUSTOM_PROPERTIES_REVISION_1 = 1;

type
  Pndu_NDIS_PCI_DEVICE_CUSTOM_PROPERTIES = ^Tndu_NDIS_PCI_DEVICE_CUSTOM_PROPERTIES;

  Tndu_NDIS_PCI_DEVICE_CUSTOM_PROPERTIES = record
    Header: Tndu_NDIS_OBJECT_HEADER;
    DeviceType: uint32;                // conventional, PCI-X, PCI-E, etc.
    CurrentSpeedAndMode: uint32;
    // PCI_DEVICE_CONVENTIONAL_xx or PCIX_MODExxx. valid only for conventional and PCI-X devices
    CurrentPayloadSize: uint32;
    // PCI_EXPRESS_MAX_PAYLOAD_SIZE, valid only for PCI-E devices
    MaxPayloadSize: uint32;
    // PCI_EXPRESS_MAX_PAYLOAD_SIZE, valid only for PCI-E devices
    MaxReadRequestSize: uint32;
    // PCI_EXPRESS_MAX_PAYLOAD_SIZE, valid only for PCI-E devices
    CurrentLinkSpeed: uint32;
    // PCI_EXPRESS_LINK_SPEED_xxx. valid only for PCI-E devices
    CurrentLinkWidth: uint32;
    // PCI_EXPRESS_LINK_WIDTH_xx. valid only for PCI-E devices
    MaxLinkSpeed: uint32;
    // PCI_EXPRESS_LINK_SPEED_xxx. valid only for PCI-E devices
    MaxLinkWidth: uint32;
    // PCI_EXPRESS_LINK_WIDTH_xx. valid only for PCI-E devices
  end;


// General Objects



//  Required OIDs


const
  NDU_OID_GEN_SUPPORTED_LIST = $00010101;
  NDU_OID_GEN_HARDWARE_STATUS = $00010102;
  NDU_OID_GEN_MEDIA_SUPPORTED = $00010103;
  NDU_OID_GEN_MEDIA_IN_USE = $00010104;
  NDU_OID_GEN_MAXIMUM_LOOKAHEAD = $00010105;
  NDU_OID_GEN_MAXIMUM_FRAME_SIZE = $00010106;
  NDU_OID_GEN_LINK_SPEED = $00010107;
  NDU_OID_GEN_TRANSMIT_BUFFER_SPACE = $00010108;
  NDU_OID_GEN_RECEIVE_BUFFER_SPACE = $00010109;
  NDU_OID_GEN_TRANSMIT_BLOCK_SIZE = $0001010A;
  NDU_OID_GEN_RECEIVE_BLOCK_SIZE = $0001010B;
  NDU_OID_GEN_VENDOR_ID = $0001010C;
  NDU_OID_GEN_VENDOR_DESCRIPTION = $0001010D;
  NDU_OID_GEN_CURRENT_PACKET_FILTER = $0001010E;
  NDU_OID_GEN_CURRENT_LOOKAHEAD = $0001010F;
  NDU_OID_GEN_DRIVER_VERSION = $00010110;
  NDU_OID_GEN_MAXIMUM_TOTAL_SIZE = $00010111;
  NDU_OID_GEN_PROTOCOL_OPTIONS = $00010112;
  NDU_OID_GEN_MAC_OPTIONS = $00010113;
  NDU_OID_GEN_MEDIA_CONNECT_STATUS = $00010114;
  NDU_OID_GEN_MAXIMUM_SEND_PACKETS = $00010115;


  //  Optional OIDs


  NDU_OID_GEN_VENDOR_DRIVER_VERSION = $00010116;
  NDU_OID_GEN_SUPPORTED_GUIDS = $00010117;
  NDU_OID_GEN_NETWORK_LAYER_ADDRESSES = $00010118;  // Set only
  NDU_OID_GEN_TRANSPORT_HEADER_OFFSET = $00010119;  // Set only
  NDU_OID_GEN_MEDIA_CAPABILITIES = $00010201;
  NDU_OID_GEN_PHYSICAL_MEDIUM = $00010202;


  // new optional for NDIS 6.0


  NDU_OID_GEN_RECEIVE_SCALE_CAPABILITIES = $00010203;  // query only
  NDU_OID_GEN_RECEIVE_SCALE_PARAMETERS = $00010204;  // query and set


  // new for NDIS 6.0. NDIS will handle on behalf of the miniports


  NDU_OID_GEN_MAC_ADDRESS = $00010205;  // query and set
  NDU_OID_GEN_MAX_LINK_SPEED = $00010206;  // query only
  NDU_OID_GEN_LINK_STATE = $00010207;  // query only


  // new and required for NDIS 6 miniports


  NDU_OID_GEN_LINK_PARAMETERS = $00010208;  // set only
  NDU_OID_GEN_INTERRUPT_MODERATION = $00010209;  // query and set
  NDU_OID_GEN_NDIS_RESERVED_3 = $0001020A;
  NDU_OID_GEN_NDIS_RESERVED_4 = $0001020B;
  NDU_OID_GEN_NDIS_RESERVED_5 = $0001020C;


  // Port related OIDs


  NDU_OID_GEN_ENUMERATE_PORTS = $0001020D;  // query only, handled by NDIS
  NDU_OID_GEN_PORT_STATE = $0001020E;  // query only, handled by NDIS
  NDU_OID_GEN_PORT_AUTHENTICATION_PARAMETERS = $0001020F;  // Set only


  // optional OID for NDIS 6 miniports


  NDU_OID_GEN_TIMEOUT_DPC_REQUEST_CAPABILITIES = $00010210; // query only


  // this OID is handled by NDIS for PCI devices


  NDU_OID_GEN_PCI_DEVICE_CUSTOM_PROPERTIES = $00010211;  // query only
  NDU_OID_GEN_NDIS_RESERVED_6 = $00010212;

  NDU_OID_GEN_MACHINE_NAME = $0001021A;  // set only
  NDU_OID_GEN_RNDIS_CONFIG_PARAMETER = $0001021B;  // Set only
  NDU_OID_GEN_VLAN_ID = $0001021C;

  NDU_OID_GEN_RECEIVE_HASH = $0001021F;  // query and set
  NDU_OID_GEN_MINIPORT_RESTART_ATTRIBUTES = $0001021D;


  // the following OIDs are used in querying interfaces


  NDU_OID_GEN_PROMISCUOUS_MODE = $00010280;  // used in querying interfaces
  NDU_OID_GEN_LAST_CHANGE = $00010281;  // used in querying interfaces
  NDU_OID_GEN_DISCONTINUITY_TIME = $00010282;  // used in querying interfaces
  NDU_OID_GEN_OPERATIONAL_STATUS = $00010283;  // used in querying interfaces
  NDU_OID_GEN_XMIT_LINK_SPEED = $00010284;  // used in querying interfaces
  NDU_OID_GEN_RCV_LINK_SPEED = $00010285;  // used in querying interfaces
  NDU_OID_GEN_UNKNOWN_PROTOS = $00010286;  // used in querying interfaces
  NDU_OID_GEN_INTERFACE_INFO = $00010287;  // used in querying interfaces
  NDU_OID_GEN_ADMIN_STATUS = $00010288;  // used in querying interfaces
  NDU_OID_GEN_ALIAS = $00010289;  // used in querying interfaces
  NDU_OID_GEN_MEDIA_CONNECT_STATUS_EX = $0001028A;  // used in querying interfaces
  NDU_OID_GEN_LINK_SPEED_EX = $0001028B;  // used in querying interfaces
  NDU_OID_GEN_MEDIA_DUPLEX_STATE = $0001028C;  // used in querying interfaces


  //  Required statistics


  NDU_OID_GEN_XMIT_OK = $00020101;
  NDU_OID_GEN_RCV_OK = $00020102;
  NDU_OID_GEN_XMIT_ERROR = $00020103;
  NDU_OID_GEN_RCV_ERROR = $00020104;
  NDU_OID_GEN_RCV_NO_BUFFER = $00020105;


  // mandatory for NDIS 6.0 and higher miniports


  NDU_OID_GEN_STATISTICS = $00020106;


  //  Optional statistics


  NDU_OID_GEN_DIRECTED_BYTES_XMIT = $00020201;
  NDU_OID_GEN_DIRECTED_FRAMES_XMIT = $00020202;
  NDU_OID_GEN_MULTICAST_BYTES_XMIT = $00020203;
  NDU_OID_GEN_MULTICAST_FRAMES_XMIT = $00020204;
  NDU_OID_GEN_BROADCAST_BYTES_XMIT = $00020205;
  NDU_OID_GEN_BROADCAST_FRAMES_XMIT = $00020206;
  NDU_OID_GEN_DIRECTED_BYTES_RCV = $00020207;
  NDU_OID_GEN_DIRECTED_FRAMES_RCV = $00020208;
  NDU_OID_GEN_MULTICAST_BYTES_RCV = $00020209;
  NDU_OID_GEN_MULTICAST_FRAMES_RCV = $0002020A;
  NDU_OID_GEN_BROADCAST_BYTES_RCV = $0002020B;
  NDU_OID_GEN_BROADCAST_FRAMES_RCV = $0002020C;
  NDU_OID_GEN_RCV_CRC_ERROR = $0002020D;
  NDU_OID_GEN_TRANSMIT_QUEUE_LENGTH = $0002020E;

  NDU_OID_GEN_GET_TIME_CAPS = $0002020F;
  NDU_OID_GEN_GET_NETCARD_TIME = $00020210;
  NDU_OID_GEN_NETCARD_LOAD = $00020211;
  NDU_OID_GEN_DEVICE_PROFILE = $00020212;


  // The following are exported by NDIS itself and are only queryable.



  // the time in milliseconds a driver took to initialize.


  NDU_OID_GEN_INIT_TIME_MS = $00020213;


  // the number of times the miniport adapter was reset


  NDU_OID_GEN_RESET_COUNTS = $00020214;


  // the number of timer the miniport reported a media state change


  NDU_OID_GEN_MEDIA_SENSE_COUNTS = $00020215;


  // the friendly name of the adapter


  NDU_OID_GEN_FRIENDLY_NAME = $00020216;


  // returns miniport information such as whether the driver is serialized or not
  // if it supports sending multiple packets, etc. refer to NDIS_MINIPORT_XXX flags


  NDU_OID_GEN_NDIS_RESERVED_1 = $00020217;


  // handled by NDIS to reset the test verification paramters on the
  // miniport


  NDU_OID_GEN_NDIS_RESERVED_2 = $00020218;


  // more optional OIDs new for NDIS 6.0


  NDU_OID_GEN_BYTES_RCV = $00020219;
  NDU_OID_GEN_BYTES_XMIT = $0002021A;
  NDU_OID_GEN_RCV_DISCARDS = $0002021B;
  NDU_OID_GEN_XMIT_DISCARDS = $0002021C;


  //  These are connection-oriented general OIDs.
  //  These replace the above OIDs for connection-oriented media.


  NDU_OID_GEN_CO_SUPPORTED_LIST = NDU_OID_GEN_SUPPORTED_LIST;
  NDU_OID_GEN_CO_HARDWARE_STATUS = NDU_OID_GEN_HARDWARE_STATUS;
  NDU_OID_GEN_CO_MEDIA_SUPPORTED = NDU_OID_GEN_MEDIA_SUPPORTED;
  NDU_OID_GEN_CO_MEDIA_IN_USE = NDU_OID_GEN_MEDIA_IN_USE;
  NDU_OID_GEN_CO_LINK_SPEED = NDU_OID_GEN_LINK_SPEED;
  NDU_OID_GEN_CO_VENDOR_ID = NDU_OID_GEN_VENDOR_ID;
  NDU_OID_GEN_CO_VENDOR_DESCRIPTION = NDU_OID_GEN_VENDOR_DESCRIPTION;
  NDU_OID_GEN_CO_DRIVER_VERSION = NDU_OID_GEN_DRIVER_VERSION;
  NDU_OID_GEN_CO_PROTOCOL_OPTIONS = NDU_OID_GEN_PROTOCOL_OPTIONS;
  NDU_OID_GEN_CO_MAC_OPTIONS = NDU_OID_GEN_MAC_OPTIONS;
  NDU_OID_GEN_CO_MEDIA_CONNECT_STATUS = NDU_OID_GEN_MEDIA_CONNECT_STATUS;
  NDU_OID_GEN_CO_VENDOR_DRIVER_VERSION = NDU_OID_GEN_VENDOR_DRIVER_VERSION;
  NDU_OID_GEN_CO_SUPPORTED_GUIDS = NDU_OID_GEN_SUPPORTED_GUIDS;
  NDU_OID_GEN_CO_GET_TIME_CAPS = NDU_OID_GEN_GET_TIME_CAPS;
  NDU_OID_GEN_CO_GET_NETCARD_TIME = NDU_OID_GEN_GET_NETCARD_TIME;
  NDU_OID_GEN_CO_MINIMUM_LINK_SPEED = $00020120;


  //  These are connection-oriented statistics OIDs.


  NDU_OID_GEN_CO_XMIT_PDUS_OK = NDU_OID_GEN_XMIT_OK;
  NDU_OID_GEN_CO_RCV_PDUS_OK = NDU_OID_GEN_RCV_OK;
  NDU_OID_GEN_CO_XMIT_PDUS_ERROR = NDU_OID_GEN_XMIT_ERROR;
  NDU_OID_GEN_CO_RCV_PDUS_ERROR = NDU_OID_GEN_RCV_ERROR;
  NDU_OID_GEN_CO_RCV_PDUS_NO_BUFFER = NDU_OID_GEN_RCV_NO_BUFFER;

  NDU_OID_GEN_CO_RCV_CRC_ERROR = NDU_OID_GEN_RCV_CRC_ERROR;
  NDU_OID_GEN_CO_TRANSMIT_QUEUE_LENGTH = NDU_OID_GEN_TRANSMIT_QUEUE_LENGTH;
  NDU_OID_GEN_CO_BYTES_XMIT = NDU_OID_GEN_DIRECTED_BYTES_XMIT;
  NDU_OID_GEN_CO_BYTES_RCV = NDU_OID_GEN_DIRECTED_BYTES_RCV;
  NDU_OID_GEN_CO_NETCARD_LOAD = NDU_OID_GEN_NETCARD_LOAD;
  NDU_OID_GEN_CO_DEVICE_PROFILE = NDU_OID_GEN_DEVICE_PROFILE;
  NDU_OID_GEN_CO_BYTES_XMIT_OUTSTANDING = $00020221;


  // 802.3 Objects (Ethernet)


  NDU_OID_802_3_PERMANENT_ADDRESS = $01010101;
  NDU_OID_802_3_CURRENT_ADDRESS = $01010102;
  NDU_OID_802_3_MULTICAST_LIST = $01010103;
  NDU_OID_802_3_MAXIMUM_LIST_SIZE = $01010104;


  // This OID has been deprecated for NDIS 6 drivers.


  NDU_OID_802_3_MAC_OPTIONS = $01010105;  // deprecated


  // This Flag has been deprecated for NDIS 6 drivers.


  NDU_NDIS_802_3_MAC_OPTION_PRIORITY = $00000001;  // deprecated

  NDU_OID_802_3_RCV_ERROR_ALIGNMENT = $01020101;
  NDU_OID_802_3_XMIT_ONE_COLLISION = $01020102;
  NDU_OID_802_3_XMIT_MORE_COLLISIONS = $01020103;

  NDU_OID_802_3_XMIT_DEFERRED = $01020201;
  NDU_OID_802_3_XMIT_MAX_COLLISIONS = $01020202;
  NDU_OID_802_3_RCV_OVERRUN = $01020203;
  NDU_OID_802_3_XMIT_UNDERRUN = $01020204;
  NDU_OID_802_3_XMIT_HEARTBEAT_FAILURE = $01020205;
  NDU_OID_802_3_XMIT_TIMES_CRS_LOST = $01020206;
  NDU_OID_802_3_XMIT_LATE_COLLISIONS = $01020207;


  // new for NDIS 6


  NDU_OID_802_3_ADD_MULTICAST_ADDRESS = $01010208;
  NDU_OID_802_3_DELETE_MULTICAST_ADDRESS = $01010209;


  // 802.5 Objects (Token-Ring)


  NDU_OID_802_5_PERMANENT_ADDRESS = $02010101;
  NDU_OID_802_5_CURRENT_ADDRESS = $02010102;
  NDU_OID_802_5_CURRENT_FUNCTIONAL = $02010103;
  NDU_OID_802_5_CURRENT_GROUP = $02010104;
  NDU_OID_802_5_LAST_OPEN_STATUS = $02010105;
  NDU_OID_802_5_CURRENT_RING_STATUS = $02010106;
  NDU_OID_802_5_CURRENT_RING_STATE = $02010107;

  NDU_OID_802_5_LINE_ERRORS = $02020101;
  NDU_OID_802_5_LOST_FRAMES = $02020102;

  NDU_OID_802_5_BURST_ERRORS = $02020201;
  NDU_OID_802_5_AC_ERRORS = $02020202;
  NDU_OID_802_5_ABORT_DELIMETERS = $02020203;
  NDU_OID_802_5_FRAME_COPIED_ERRORS = $02020204;
  NDU_OID_802_5_FREQUENCY_ERRORS = $02020205;
  NDU_OID_802_5_TOKEN_ERRORS = $02020206;
  NDU_OID_802_5_INTERNAL_ERRORS = $02020207;



  // FDDI Objects


  NDU_OID_FDDI_LONG_PERMANENT_ADDR = $03010101;
  NDU_OID_FDDI_LONG_CURRENT_ADDR = $03010102;
  NDU_OID_FDDI_LONG_MULTICAST_LIST = $03010103;
  NDU_OID_FDDI_LONG_MAX_LIST_SIZE = $03010104;
  NDU_OID_FDDI_SHORT_PERMANENT_ADDR = $03010105;
  NDU_OID_FDDI_SHORT_CURRENT_ADDR = $03010106;
  NDU_OID_FDDI_SHORT_MULTICAST_LIST = $03010107;
  NDU_OID_FDDI_SHORT_MAX_LIST_SIZE = $03010108;

  NDU_OID_FDDI_ATTACHMENT_TYPE = $03020101;
  NDU_OID_FDDI_UPSTREAM_NODE_LONG = $03020102;
  NDU_OID_FDDI_DOWNSTREAM_NODE_LONG = $03020103;
  NDU_OID_FDDI_FRAME_ERRORS = $03020104;
  NDU_OID_FDDI_FRAMES_LOST = $03020105;
  NDU_OID_FDDI_RING_MGT_STATE = $03020106;
  NDU_OID_FDDI_LCT_FAILURES = $03020107;
  NDU_OID_FDDI_LEM_REJECTS = $03020108;
  NDU_OID_FDDI_LCONNECTION_STATE = $03020109;

  NDU_OID_FDDI_SMT_STATION_ID = $03030201;
  NDU_OID_FDDI_SMT_OP_VERSION_ID = $03030202;
  NDU_OID_FDDI_SMT_HI_VERSION_ID = $03030203;
  NDU_OID_FDDI_SMT_LO_VERSION_ID = $03030204;
  NDU_OID_FDDI_SMT_MANUFACTURER_DATA = $03030205;
  NDU_OID_FDDI_SMT_USER_DATA = $03030206;
  NDU_OID_FDDI_SMT_MIB_VERSION_ID = $03030207;
  NDU_OID_FDDI_SMT_MAC_CT = $03030208;
  NDU_OID_FDDI_SMT_NON_MASTER_CT = $03030209;
  NDU_OID_FDDI_SMT_MASTER_CT = $0303020A;
  NDU_OID_FDDI_SMT_AVAILABLE_PATHS = $0303020B;
  NDU_OID_FDDI_SMT_CONFIG_CAPABILITIES = $0303020C;
  NDU_OID_FDDI_SMT_CONFIG_POLICY = $0303020D;
  NDU_OID_FDDI_SMT_CONNECTION_POLICY = $0303020E;
  NDU_OID_FDDI_SMT_T_NOTIFY = $0303020F;
  NDU_OID_FDDI_SMT_STAT_RPT_POLICY = $03030210;
  NDU_OID_FDDI_SMT_TRACE_MAX_EXPIRATION = $03030211;
  NDU_OID_FDDI_SMT_PORT_INDEXES = $03030212;
  NDU_OID_FDDI_SMT_MAC_INDEXES = $03030213;
  NDU_OID_FDDI_SMT_BYPASS_PRESENT = $03030214;
  NDU_OID_FDDI_SMT_ECM_STATE = $03030215;
  NDU_OID_FDDI_SMT_CF_STATE = $03030216;
  NDU_OID_FDDI_SMT_HOLD_STATE = $03030217;
  NDU_OID_FDDI_SMT_REMOTE_DISCONNECT_FLAG = $03030218;
  NDU_OID_FDDI_SMT_STATION_STATUS = $03030219;
  NDU_OID_FDDI_SMT_PEER_WRAP_FLAG = $0303021A;
  NDU_OID_FDDI_SMT_MSG_TIME_STAMP = $0303021B;
  NDU_OID_FDDI_SMT_TRANSITION_TIME_STAMP = $0303021C;
  NDU_OID_FDDI_SMT_SET_COUNT = $0303021D;
  NDU_OID_FDDI_SMT_LAST_SET_STATION_ID = $0303021E;
  NDU_OID_FDDI_MAC_FRAME_STATUS_FUNCTIONS = $0303021F;
  NDU_OID_FDDI_MAC_BRIDGE_FUNCTIONS = $03030220;
  NDU_OID_FDDI_MAC_T_MAX_CAPABILITY = $03030221;
  NDU_OID_FDDI_MAC_TVX_CAPABILITY = $03030222;
  NDU_OID_FDDI_MAC_AVAILABLE_PATHS = $03030223;
  NDU_OID_FDDI_MAC_CURRENT_PATH = $03030224;
  NDU_OID_FDDI_MAC_UPSTREAM_NBR = $03030225;
  NDU_OID_FDDI_MAC_DOWNSTREAM_NBR = $03030226;
  NDU_OID_FDDI_MAC_OLD_UPSTREAM_NBR = $03030227;
  NDU_OID_FDDI_MAC_OLD_DOWNSTREAM_NBR = $03030228;
  NDU_OID_FDDI_MAC_DUP_ADDRESS_TEST = $03030229;
  NDU_OID_FDDI_MAC_REQUESTED_PATHS = $0303022A;
  NDU_OID_FDDI_MAC_DOWNSTREAM_PORT_TYPE = $0303022B;
  NDU_OID_FDDI_MAC_INDEX = $0303022C;
  NDU_OID_FDDI_MAC_SMT_ADDRESS = $0303022D;
  NDU_OID_FDDI_MAC_LONG_GRP_ADDRESS = $0303022E;
  NDU_OID_FDDI_MAC_SHORT_GRP_ADDRESS = $0303022F;
  NDU_OID_FDDI_MAC_T_REQ = $03030230;
  NDU_OID_FDDI_MAC_T_NEG = $03030231;
  NDU_OID_FDDI_MAC_T_MAX = $03030232;
  NDU_OID_FDDI_MAC_TVX_VALUE = $03030233;
  NDU_OID_FDDI_MAC_T_PRI0 = $03030234;
  NDU_OID_FDDI_MAC_T_PRI1 = $03030235;
  NDU_OID_FDDI_MAC_T_PRI2 = $03030236;
  NDU_OID_FDDI_MAC_T_PRI3 = $03030237;
  NDU_OID_FDDI_MAC_T_PRI4 = $03030238;
  NDU_OID_FDDI_MAC_T_PRI5 = $03030239;
  NDU_OID_FDDI_MAC_T_PRI6 = $0303023A;
  NDU_OID_FDDI_MAC_FRAME_CT = $0303023B;
  NDU_OID_FDDI_MAC_COPIED_CT = $0303023C;
  NDU_OID_FDDI_MAC_TRANSMIT_CT = $0303023D;
  NDU_OID_FDDI_MAC_TOKEN_CT = $0303023E;
  NDU_OID_FDDI_MAC_ERROR_CT = $0303023F;
  NDU_OID_FDDI_MAC_LOST_CT = $03030240;
  NDU_OID_FDDI_MAC_TVX_EXPIRED_CT = $03030241;
  NDU_OID_FDDI_MAC_NOT_COPIED_CT = $03030242;
  NDU_OID_FDDI_MAC_LATE_CT = $03030243;
  NDU_OID_FDDI_MAC_RING_OP_CT = $03030244;
  NDU_OID_FDDI_MAC_FRAME_ERROR_THRESHOLD = $03030245;
  NDU_OID_FDDI_MAC_FRAME_ERROR_RATIO = $03030246;
  NDU_OID_FDDI_MAC_NOT_COPIED_THRESHOLD = $03030247;
  NDU_OID_FDDI_MAC_NOT_COPIED_RATIO = $03030248;
  NDU_OID_FDDI_MAC_RMT_STATE = $03030249;
  NDU_OID_FDDI_MAC_DA_FLAG = $0303024A;
  NDU_OID_FDDI_MAC_UNDA_FLAG = $0303024B;
  NDU_OID_FDDI_MAC_FRAME_ERROR_FLAG = $0303024C;
  NDU_OID_FDDI_MAC_NOT_COPIED_FLAG = $0303024D;
  NDU_OID_FDDI_MAC_MA_UNITDATA_AVAILABLE = $0303024E;
  NDU_OID_FDDI_MAC_HARDWARE_PRESENT = $0303024F;
  NDU_OID_FDDI_MAC_MA_UNITDATA_ENABLE = $03030250;
  NDU_OID_FDDI_PATH_INDEX = $03030251;
  NDU_OID_FDDI_PATH_RING_LATENCY = $03030252;
  NDU_OID_FDDI_PATH_TRACE_STATUS = $03030253;
  NDU_OID_FDDI_PATH_SBA_PAYLOAD = $03030254;
  NDU_OID_FDDI_PATH_SBA_OVERHEAD = $03030255;
  NDU_OID_FDDI_PATH_CONFIGURATION = $03030256;
  NDU_OID_FDDI_PATH_T_R_MODE = $03030257;
  NDU_OID_FDDI_PATH_SBA_AVAILABLE = $03030258;
  NDU_OID_FDDI_PATH_TVX_LOWER_BOUND = $03030259;
  NDU_OID_FDDI_PATH_T_MAX_LOWER_BOUND = $0303025A;
  NDU_OID_FDDI_PATH_MAX_T_REQ = $0303025B;
  NDU_OID_FDDI_PORT_MY_TYPE = $0303025C;
  NDU_OID_FDDI_PORT_NEIGHBOR_TYPE = $0303025D;
  NDU_OID_FDDI_PORT_CONNECTION_POLICIES = $0303025E;
  NDU_OID_FDDI_PORT_MAC_INDICATED = $0303025F;
  NDU_OID_FDDI_PORT_CURRENT_PATH = $03030260;
  NDU_OID_FDDI_PORT_REQUESTED_PATHS = $03030261;
  NDU_OID_FDDI_PORT_MAC_PLACEMENT = $03030262;
  NDU_OID_FDDI_PORT_AVAILABLE_PATHS = $03030263;
  NDU_OID_FDDI_PORT_MAC_LOOP_TIME = $03030264;
  NDU_OID_FDDI_PORT_PMD_CLASS = $03030265;
  NDU_OID_FDDI_PORT_CONNECTION_CAPABILITIES = $03030266;
  NDU_OID_FDDI_PORT_INDEX = $03030267;
  NDU_OID_FDDI_PORT_MAINT_LS = $03030268;
  NDU_OID_FDDI_PORT_BS_FLAG = $03030269;
  NDU_OID_FDDI_PORT_PC_LS = $0303026A;
  NDU_OID_FDDI_PORT_EB_ERROR_CT = $0303026B;
  NDU_OID_FDDI_PORT_LCT_FAIL_CT = $0303026C;
  NDU_OID_FDDI_PORT_LER_ESTIMATE = $0303026D;
  NDU_OID_FDDI_PORT_LEM_REJECT_CT = $0303026E;
  NDU_OID_FDDI_PORT_LEM_CT = $0303026F;
  NDU_OID_FDDI_PORT_LER_CUTOFF = $03030270;
  NDU_OID_FDDI_PORT_LER_ALARM = $03030271;
  NDU_OID_FDDI_PORT_CONNNECT_STATE = $03030272;
  NDU_OID_FDDI_PORT_PCM_STATE = $03030273;
  NDU_OID_FDDI_PORT_PC_WITHHOLD = $03030274;
  NDU_OID_FDDI_PORT_LER_FLAG = $03030275;
  NDU_OID_FDDI_PORT_HARDWARE_PRESENT = $03030276;
  NDU_OID_FDDI_SMT_STATION_ACTION = $03030277;
  NDU_OID_FDDI_PORT_ACTION = $03030278;
  NDU_OID_FDDI_IF_DESCR = $03030279;
  NDU_OID_FDDI_IF_TYPE = $0303027A;
  NDU_OID_FDDI_IF_MTU = $0303027B;
  NDU_OID_FDDI_IF_SPEED = $0303027C;
  NDU_OID_FDDI_IF_PHYS_ADDRESS = $0303027D;
  NDU_OID_FDDI_IF_ADMIN_STATUS = $0303027E;
  NDU_OID_FDDI_IF_OPER_STATUS = $0303027F;
  NDU_OID_FDDI_IF_LAST_CHANGE = $03030280;
  NDU_OID_FDDI_IF_IN_OCTETS = $03030281;
  NDU_OID_FDDI_IF_IN_UCAST_PKTS = $03030282;
  NDU_OID_FDDI_IF_IN_NUCAST_PKTS = $03030283;
  NDU_OID_FDDI_IF_IN_DISCARDS = $03030284;
  NDU_OID_FDDI_IF_IN_ERRORS = $03030285;
  NDU_OID_FDDI_IF_IN_UNKNOWN_PROTOS = $03030286;
  NDU_OID_FDDI_IF_OUT_OCTETS = $03030287;
  NDU_OID_FDDI_IF_OUT_UCAST_PKTS = $03030288;
  NDU_OID_FDDI_IF_OUT_NUCAST_PKTS = $03030289;
  NDU_OID_FDDI_IF_OUT_DISCARDS = $0303028A;
  NDU_OID_FDDI_IF_OUT_ERRORS = $0303028B;
  NDU_OID_FDDI_IF_OUT_QLEN = $0303028C;
  NDU_OID_FDDI_IF_SPECIFIC = $0303028D;


  // WAN objects


  NDU_OID_WAN_PERMANENT_ADDRESS = $04010101;
  NDU_OID_WAN_CURRENT_ADDRESS = $04010102;
  NDU_OID_WAN_QUALITY_OF_SERVICE = $04010103;
  NDU_OID_WAN_PROTOCOL_TYPE = $04010104;
  NDU_OID_WAN_MEDIUM_SUBTYPE = $04010105;
  NDU_OID_WAN_HEADER_FORMAT = $04010106;

  NDU_OID_WAN_GET_INFO = $04010107;
  NDU_OID_WAN_SET_LINK_INFO = $04010108;
  NDU_OID_WAN_GET_LINK_INFO = $04010109;

  NDU_OID_WAN_LINE_COUNT = $0401010A;
  NDU_OID_WAN_PROTOCOL_CAPS = $0401010B;

  NDU_OID_WAN_GET_BRIDGE_INFO = $0401020A;
  NDU_OID_WAN_SET_BRIDGE_INFO = $0401020B;
  NDU_OID_WAN_GET_COMP_INFO = $0401020C;
  NDU_OID_WAN_SET_COMP_INFO = $0401020D;
  NDU_OID_WAN_GET_STATS_INFO = $0401020E;


  //  These are connection-oriented WAN OIDs.
  //  These replace the above OIDs for CoNDIS WAN Miniports


  NDU_OID_WAN_CO_GET_INFO = $04010180;
  NDU_OID_WAN_CO_SET_LINK_INFO = $04010181;
  NDU_OID_WAN_CO_GET_LINK_INFO = $04010182;
  NDU_OID_WAN_CO_GET_COMP_INFO = $04010280;
  NDU_OID_WAN_CO_SET_COMP_INFO = $04010281;
  NDU_OID_WAN_CO_GET_STATS_INFO = $04010282;


  // LocalTalk objects


  NDU_OID_LTALK_CURRENT_NODE_ID = $05010102;

  NDU_OID_LTALK_IN_BROADCASTS = $05020101;
  NDU_OID_LTALK_IN_LENGTH_ERRORS = $05020102;

  NDU_OID_LTALK_OUT_NO_HANDLERS = $05020201;
  NDU_OID_LTALK_COLLISIONS = $05020202;
  NDU_OID_LTALK_DEFERS = $05020203;
  NDU_OID_LTALK_NO_DATA_ERRORS = $05020204;
  NDU_OID_LTALK_RANDOM_CTS_ERRORS = $05020205;
  NDU_OID_LTALK_FCS_ERRORS = $05020206;


  // Arcnet objects


  NDU_OID_ARCNET_PERMANENT_ADDRESS = $06010101;
  NDU_OID_ARCNET_CURRENT_ADDRESS = $06010102;

  NDU_OID_ARCNET_RECONFIGURATIONS = $06020201;


  // TAPI objects


  NDU_OID_TAPI_ACCEPT = $07030101;
  NDU_OID_TAPI_ANSWER = $07030102;
  NDU_OID_TAPI_CLOSE = $07030103;
  NDU_OID_TAPI_CLOSE_CALL = $07030104;
  NDU_OID_TAPI_CONDITIONAL_MEDIA_DETECTION = $07030105;
  NDU_OID_TAPI_CONFIG_DIALOG = $07030106;
  NDU_OID_TAPI_DEV_SPECIFIC = $07030107;
  NDU_OID_TAPI_DIAL = $07030108;
  NDU_OID_TAPI_DROP = $07030109;
  NDU_OID_TAPI_GET_ADDRESS_CAPS = $0703010A;
  NDU_OID_TAPI_GET_ADDRESS_ID = $0703010B;
  NDU_OID_TAPI_GET_ADDRESS_STATUS = $0703010C;
  NDU_OID_TAPI_GET_CALL_ADDRESS_ID = $0703010D;
  NDU_OID_TAPI_GET_CALL_INFO = $0703010E;
  NDU_OID_TAPI_GET_CALL_STATUS = $0703010F;
  NDU_OID_TAPI_GET_DEV_CAPS = $07030110;
  NDU_OID_TAPI_GET_DEV_CONFIG = $07030111;
  NDU_OID_TAPI_GET_EXTENSION_ID = $07030112;
  NDU_OID_TAPI_GET_ID = $07030113;
  NDU_OID_TAPI_GET_LINE_DEV_STATUS = $07030114;
  NDU_OID_TAPI_MAKE_CALL = $07030115;
  NDU_OID_TAPI_NEGOTIATE_EXT_VERSION = $07030116;
  NDU_OID_TAPI_OPEN = $07030117;
  NDU_OID_TAPI_PROVIDER_INITIALIZE = $07030118;
  NDU_OID_TAPI_PROVIDER_SHUTDOWN = $07030119;
  NDU_OID_TAPI_SECURE_CALL = $0703011A;
  NDU_OID_TAPI_SELECT_EXT_VERSION = $0703011B;
  NDU_OID_TAPI_SEND_USER_USER_INFO = $0703011C;
  NDU_OID_TAPI_SET_APP_SPECIFIC = $0703011D;
  NDU_OID_TAPI_SET_CALL_PARAMS = $0703011E;
  NDU_OID_TAPI_SET_DEFAULT_MEDIA_DETECTION = $0703011F;
  NDU_OID_TAPI_SET_DEV_CONFIG = $07030120;
  NDU_OID_TAPI_SET_MEDIA_MODE = $07030121;
  NDU_OID_TAPI_SET_STATUS_MESSAGES = $07030122;
  NDU_OID_TAPI_GATHER_DIGITS = $07030123;
  NDU_OID_TAPI_MONITOR_DIGITS = $07030124;


  // ATM Connection Oriented OIDs


  NDU_OID_ATM_SUPPORTED_VC_RATES = $08010101;
  NDU_OID_ATM_SUPPORTED_SERVICE_CATEGORY = $08010102;
  NDU_OID_ATM_SUPPORTED_AAL_TYPES = $08010103;
  NDU_OID_ATM_HW_CURRENT_ADDRESS = $08010104;
  NDU_OID_ATM_MAX_ACTIVE_VCS = $08010105;
  NDU_OID_ATM_MAX_ACTIVE_VCI_BITS = $08010106;
  NDU_OID_ATM_MAX_ACTIVE_VPI_BITS = $08010107;
  NDU_OID_ATM_MAX_AAL0_PACKET_SIZE = $08010108;
  NDU_OID_ATM_MAX_AAL1_PACKET_SIZE = $08010109;
  NDU_OID_ATM_MAX_AAL34_PACKET_SIZE = $0801010A;
  NDU_OID_ATM_MAX_AAL5_PACKET_SIZE = $0801010B;

  NDU_OID_ATM_SIGNALING_VPIVCI = $08010201;
  NDU_OID_ATM_ASSIGNED_VPI = $08010202;
  NDU_OID_ATM_ACQUIRE_ACCESS_NET_RESOURCES = $08010203;
  NDU_OID_ATM_RELEASE_ACCESS_NET_RESOURCES = $08010204;
  NDU_OID_ATM_ILMI_VPIVCI = $08010205;
  NDU_OID_ATM_DIGITAL_BROADCAST_VPIVCI = $08010206;
  NDU_OID_ATM_GET_NEAREST_FLOW = $08010207;
  NDU_OID_ATM_ALIGNMENT_REQUIRED = $08010208;
  NDU_OID_ATM_LECS_ADDRESS = $08010209;
  NDU_OID_ATM_SERVICE_ADDRESS = $0801020A;

  NDU_OID_ATM_CALL_PROCEEDING = $0801020B;  // UNI 4.0
  NDU_OID_ATM_CALL_ALERTING = $0801020C;  // UNI 4.0
  NDU_OID_ATM_PARTY_ALERTING = $0801020D;  // UNI 4.0
  NDU_OID_ATM_CALL_NOTIFY = $0801020E;  // UNI 4.0

  NDU_OID_ATM_MY_IP_NM_ADDRESS = $0801020F;


  //  ATM specific statistics OIDs.


  NDU_OID_ATM_RCV_CELLS_OK = $08020101;
  NDU_OID_ATM_XMIT_CELLS_OK = $08020102;
  NDU_OID_ATM_RCV_CELLS_DROPPED = $08020103;

  NDU_OID_ATM_RCV_INVALID_VPI_VCI = $08020201;
  NDU_OID_ATM_CELLS_HEC_ERROR = $08020202;
  NDU_OID_ATM_RCV_REASSEMBLY_ERROR = $08020203;


  // IEEE 802.11 OIDs


  NDU_OID_802_11_BSSID = $0D010101;
  NDU_OID_802_11_SSID = $0D010102;
  NDU_OID_802_11_NETWORK_TYPES_SUPPORTED = $0D010203;
  NDU_OID_802_11_NETWORK_TYPE_IN_USE = $0D010204;
  NDU_OID_802_11_TX_POWER_LEVEL = $0D010205;
  NDU_OID_802_11_RSSI = $0D010206;
  NDU_OID_802_11_RSSI_TRIGGER = $0D010207;
  NDU_OID_802_11_INFRASTRUCTURE_MODE = $0D010108;
  NDU_OID_802_11_FRAGMENTATION_THRESHOLD = $0D010209;
  NDU_OID_802_11_RTS_THRESHOLD = $0D01020A;
  NDU_OID_802_11_NUMBER_OF_ANTENNAS = $0D01020B;
  NDU_OID_802_11_RX_ANTENNA_SELECTED = $0D01020C;
  NDU_OID_802_11_TX_ANTENNA_SELECTED = $0D01020D;
  NDU_OID_802_11_SUPPORTED_RATES = $0D01020E;
  NDU_OID_802_11_DESIRED_RATES = $0D010210;
  NDU_OID_802_11_CONFIGURATION = $0D010211;
  NDU_OID_802_11_STATISTICS = $0D020212;
  NDU_OID_802_11_ADD_WEP = $0D010113;
  NDU_OID_802_11_REMOVE_WEP = $0D010114;
  NDU_OID_802_11_DISASSOCIATE = $0D010115;
  NDU_OID_802_11_POWER_MODE = $0D010216;
  NDU_OID_802_11_BSSID_LIST = $0D010217;
  NDU_OID_802_11_AUTHENTICATION_MODE = $0D010118;
  NDU_OID_802_11_PRIVACY_FILTER = $0D010119;
  NDU_OID_802_11_BSSID_LIST_SCAN = $0D01011A;
  NDU_OID_802_11_WEP_STATUS = $0D01011B;
  // Renamed to reflect better the extended set of encryption status
  NDU_OID_802_11_ENCRYPTION_STATUS = NDU_OID_802_11_WEP_STATUS;
  NDU_OID_802_11_RELOAD_DEFAULTS = $0D01011C;
  // Added to allow key mapping and default keys
  NDU_OID_802_11_ADD_KEY = $0D01011D;
  NDU_OID_802_11_REMOVE_KEY = $0D01011E;
  NDU_OID_802_11_ASSOCIATION_INFORMATION = $0D01011F;
  NDU_OID_802_11_TEST = $0D010120;
  NDU_OID_802_11_MEDIA_STREAM_MODE = $0D010121;
  NDU_OID_802_11_CAPABILITY = $0D010122;
  NDU_OID_802_11_PMKID = $0D010123;
  NDU_OID_802_11_NON_BCAST_SSID_LIST = $0D010124;
  NDU_OID_802_11_RADIO_STATUS = $0D010125;


  // some of well known Ethernet frame types (in big endian notation)


  NDU_NDIS_ETH_TYPE_IPV4 = $0800;  // IPV4
  NDU_NDIS_ETH_TYPE_ARP = $0806;  // ARP
  NDU_NDIS_ETH_TYPE_IPV6 = $86dd;  // IPV6
  NDU_NDIS_ETH_TYPE_802_1X = $888e;  // 802.1x
  NDU_NDIS_ETH_TYPE_802_1Q = $8100;  // 802.1p
  NDU_NDIS_ETH_TYPE_SLOW_PROTOCOL = $8809;  // Slow protocols (LACP, etc.)

  NDU_NDIS_802_11_LENGTH_SSID = 32;
  NDU_NDIS_802_11_LENGTH_RATES = 8;
  NDU_NDIS_802_11_LENGTH_RATES_EX = 16;


  //http://lxr.free-electrons.com/source/drivers/staging/rtl8188eu/include/ieee80211.h#L562
  //http://w1.fi/wpa_supplicant/devel/ieee802__11__defs_8h_source.html
  // Information Element IDs */
  WLAN_EID_SSID = 0;
  WLAN_EID_SUPP_RATES = 1;
  WLAN_EID_FH_PARAMS = 2;
  WLAN_EID_DS_PARAMS = 3;
  WLAN_EID_CF_PARAMS = 4;
  WLAN_EID_TIM = 5;
  WLAN_EID_IBSS_PARAMS = 6;
  WLAN_EID_COUNTRY = 7;
  WLAN_EID_REQUEST = 10;
  WLAN_EID_CHALLENGE = 16;
  // EIDs defined by IEEE 802.11h - START */
  WLAN_EID_PWR_CONSTRAINT = 32;
  WLAN_EID_PWR_CAPABILITY = 33;
  WLAN_EID_TPC_REQUEST = 34;
  WLAN_EID_TPC_REPORT = 35;
  WLAN_EID_SUPPORTED_CHANNELS = 36;
  WLAN_EID_CHANNEL_SWITCH = 37;
  WLAN_EID_MEASURE_REQUEST = 38;
  WLAN_EID_MEASURE_REPORT = 39;
  WLAN_EID_QUITE = 40;
  WLAN_EID_IBSS_DFS = 41;
  // EIDs defined by IEEE 802.11h - END */
  WLAN_EID_ERP_INFO = 42;
  WLAN_EID_HT_CAP = 45;
  WLAN_EID_RSN = 48;
  WLAN_EID_EXT_SUPP_RATES = 50;
  WLAN_EID_POWER_CONSTRAINT = 52;
  WLAN_EID_MOBILITY_DOMAIN = 54;
  WLAN_EID_FAST_BSS_TRANSITION = 55;
  WLAN_EID_TIMEOUT_INTERVAL = 56;
  WLAN_EID_RIC_DATA = 57;
  WLAN_EID_HT_OPERATION = 61;
  WLAN_EID_SECONDARY_CHANNEL_OFFSET = 62;
  WLAN_EID_20_40_BSS_COEXISTENCE = 72;
  WLAN_EID_20_40_BSS_INTOLERANT = 73;
  WLAN_EID_OVERLAPPING_BSS_SCAN_PARAMS = 74;
  WLAN_EID_MMIE = 76;
  WLAN_EID_VENDOR_SPECIFIC = 221;

// IEEE 802.11 Structures and definitions

// new types for Media Specific Indications

type
  Pndu_NDIS_802_11_STATUS_TYPE = ^Tndu_NDIS_802_11_STATUS_TYPE;
  Tndu_NDIS_802_11_STATUS_TYPE = (
    Ndis802_11StatusType_Authentication,
    Ndis802_11StatusType_MediaStreamMode,
    Ndis802_11StatusType_PMKID_CandidateList,
    Ndis802_11StatusTypeMax    // not a real type, defined as an upper bound
    );

  Tndu_NDIS_802_11_MAC_ADDRESS = array[0..5] of uchar;

  Tndu_NDIS_802_11_STATUS_INDICATION = record
    StatusType: Tndu_NDIS_802_11_STATUS_TYPE;
  end;

const
  // mask for authentication/integrity fields
  NDU_NDIS_802_11_AUTH_REQUEST_AUTH_FIELDS = $0f;

  NDU_NDIS_802_11_AUTH_REQUEST_REAUTH = $01;
  NDU_NDIS_802_11_AUTH_REQUEST_KEYUPDATE = $02;
  NDU_NDIS_802_11_AUTH_REQUEST_PAIRWISE_ERROR = $06;
  NDU_NDIS_802_11_AUTH_REQUEST_GROUP_ERROR = $0E;

type
  Pndu_NDIS_802_11_AUTHENTICATION_REQUEST = ^Tndu_NDIS_802_11_AUTHENTICATION_REQUEST;

  Tndu_NDIS_802_11_AUTHENTICATION_REQUEST = record
    Length: ulong;  // Length of structure
    Bssid: Tndu_NDIS_802_11_MAC_ADDRESS;
    Flags: ulong;
  end;

  //Added new types for PMKID Candidate lists.
  Pndu_PMKID_CANDIDATE = ^Tndu_PMKID_CANDIDATE;

  Tndu_PMKID_CANDIDATE = record
    BSSID: Tndu_NDIS_802_11_MAC_ADDRESS;
    Flags: ulong;
  end;

  Pndu_NDIS_802_11_PMKID_CANDIDATE_LIST = ^Tndu_NDIS_802_11_PMKID_CANDIDATE_LIST;

  Tndu_NDIS_802_11_PMKID_CANDIDATE_LIST = record
    Version: ulong; // Version of the structure
    NumCandidates: ulong; // No. of pmkid candidates
    CandidateList: array[0..0] of Tndu_PMKID_CANDIDATE;
  end;

const
  //Flags for PMKID Candidate list structure
  NDU_NDIS_802_11_PMKID_CANDIDATE_PREAUTH_ENABLED = $01;

type
  // Added new types for OFDM 5G and 2.4G
  Pndu_NDIS_802_11_NETWORK_TYPE = ^Tndu_NDIS_802_11_NETWORK_TYPE;
  Tndu_NDIS_802_11_NETWORK_TYPE = (
    Ndis802_11FH,
    Ndis802_11DS,
    Ndis802_11OFDM5,
    Ndis802_11OFDM24,
    Ndis802_11Automode,
    Ndis802_11NetworkTypeMax    // not a real type, defined as an upper bound
    );

  Pndu_NDIS_802_11_NETWORK_TYPE_LIST = ^Tndu_NDIS_802_11_NETWORK_TYPE_LIST;

  Tndu_NDIS_802_11_NETWORK_TYPE_LIST = record
    NumberOfItems: ulong;  // in list below, at least 1
    NetworkType: array[0..0] of Tndu_NDIS_802_11_NETWORK_TYPE;
  end;

  Pndu_NDIS_802_11_POWER_MODE = ^Tndu_NDIS_802_11_POWER_MODE;
  Tndu_NDIS_802_11_POWER_MODE = (
    Ndis802_11PowerModeCAM,
    Ndis802_11PowerModeMAX_PSP,
    Ndis802_11PowerModeFast_PSP,
    Ndis802_11PowerModeMax      // not a real mode, defined as an upper bound
    );

  Tndu_NDIS_802_11_TX_POWER_LEVEL = ulong; // in milliwatts


  // Received Signal Strength Indication


  Tndu_NDIS_802_11_RSSI = long;  // in dBm

  Pndu_NDIS_802_11_CONFIGURATION_FH = ^Tndu_NDIS_802_11_CONFIGURATION_FH;

  Tndu_NDIS_802_11_CONFIGURATION_FH = record
    Length: ulong;        // Length of structure
    HopPattern: ulong;    // As defined by 802.11, MSB set
    HopSet: ulong;        // to one if non-802.11
    DwellTime: ulong;      // units are Kusec
  end;

  Pndu_NDIS_802_11_CONFIGURATION = ^Tndu_NDIS_802_11_CONFIGURATION;

  Tndu_NDIS_802_11_CONFIGURATION = record
    Length: ulong;        // Length of structure
    BeaconPeriod: ulong;  // units are Kusec
    ATIMWindow: ulong;    // units are Kusec
    DSConfig: ulong;      // Frequency, units are kHz
    FHConfig: Tndu_NDIS_802_11_CONFIGURATION_FH;
  end;

  Pndu_NDIS_802_11_STATISTICS = ^Tndu_NDIS_802_11_STATISTICS;

  Tndu_NDIS_802_11_STATISTICS = record
    Length: ulong;        // Length of structure
    TransmittedFragmentCount: LARGE_INTEGER;
    MulticastTransmittedFrameCount: LARGE_INTEGER;
    FailedCount: LARGE_INTEGER;
    RetryCount: LARGE_INTEGER;
    MultipleRetryCount: LARGE_INTEGER;
    RTSSuccessCount: LARGE_INTEGER;
    RTSFailureCount: LARGE_INTEGER;
    ACKFailureCount: LARGE_INTEGER;
    FrameDuplicateCount: LARGE_INTEGER;
    ReceivedFragmentCount: LARGE_INTEGER;
    MulticastReceivedFrameCount: LARGE_INTEGER;
    FCSErrorCount: LARGE_INTEGER;
    TKIPLocalMICFailures: LARGE_INTEGER;
    TKIPICVErrorCount: LARGE_INTEGER;
    TKIPCounterMeasuresInvoked: LARGE_INTEGER;
    TKIPReplays: LARGE_INTEGER;
    CCMPFormatErrors: LARGE_INTEGER;
    CCMPReplays: LARGE_INTEGER;
    CCMPDecryptErrors: LARGE_INTEGER;
    FourWayHandshakeFailures: LARGE_INTEGER;
    WEPUndecryptableCount: LARGE_INTEGER;
    WEPICVErrorCount: LARGE_INTEGER;
    DecryptSuccessCount: LARGE_INTEGER;
    DecryptFailureCount: LARGE_INTEGER;
  end;

  Tndu_NDIS_802_11_KEY_INDEX = ulong;
  Tndu_NDIS_802_11_KEY_RSC = ulonglong;

  // Key mapping keys require a BSSID
  Pndu_NDIS_802_11_KEY = ^Tndu_NDIS_802_11_KEY;

  Tndu_NDIS_802_11_KEY = record
    Length: ulong;                          // Length of this structure
    KeyIndex: ulong;
    KeyLength: ulong;                        // length of key in bytes
    BSSID: Tndu_NDIS_802_11_MAC_ADDRESS;
    KeyRSC: Tndu_NDIS_802_11_KEY_RSC;
    KeyMaterial: array[0..0] of uchar;      // variable length depending on above field
  end;

  Pndu_NDIS_802_11_REMOVE_KEY = ^Tndu_NDIS_802_11_REMOVE_KEY;

  Tndu_NDIS_802_11_REMOVE_KEY = record
    Length: ulong;                          // Length of this structure
    KeyIndex: ulong;
    BSSID: Tndu_NDIS_802_11_MAC_ADDRESS;
  end;

  Pndu_NDIS_802_11_WEP = ^Tndu_NDIS_802_11_WEP;

  Tndu_NDIS_802_11_WEP = record
    Length: ulong;                          // Length of this structure
    KeyIndex: ulong;                        // 0 is the per-client key, 1-N are the
    // global keys
    KeyLength: ulong;                        // length of key in bytes
    KeyMaterial: array[0..0] of uchar;      // variable length depending on above field
  end;

  Pndu_NDIS_802_11_NETWORK_INFRASTRUCTURE = ^Tndu_NDIS_802_11_NETWORK_INFRASTRUCTURE;
  Tndu_NDIS_802_11_NETWORK_INFRASTRUCTURE = (
    Ndis802_11IBSS,
    Ndis802_11Infrastructure,
    Ndis802_11AutoUnknown,
    Ndis802_11InfrastructureMax         // Not a real value, defined as upper bound
    );

  // Add new authentication modes
  Pndu_NDIS_802_11_AUTHENTICATION_MODE = ^Tndu_NDIS_802_11_AUTHENTICATION_MODE;
  Tndu_NDIS_802_11_AUTHENTICATION_MODE = (
    Ndis802_11AuthModeOpen,
    Ndis802_11AuthModeShared,
    Ndis802_11AuthModeAutoSwitch,
    Ndis802_11AuthModeWPA,
    Ndis802_11AuthModeWPAPSK,
    Ndis802_11AuthModeWPANone,
    Ndis802_11AuthModeWPA2,
    Ndis802_11AuthModeWPA2PSK,
    Ndis802_11AuthModeMax               // Not a real mode, defined as upper bound
    );

  Tndu_NDIS_802_11_RATES = array[0..NDU_NDIS_802_11_LENGTH_RATES - 1] of
    uchar;          // Set of 8 data rates
  Tndu_NDIS_802_11_RATES_EX = array[0..NDU_NDIS_802_11_LENGTH_RATES_EX - 1] of
    uchar;   // Set of 16 data rates

  Pndu_NDIS_802_11_SSID = ^Tndu_NDIS_802_11_SSID;

  Tndu_NDIS_802_11_SSID = record
    SsidLength: ulong;                  // length of SSID field below, in bytes;
    // this can be zero.
    Ssid: array[0..NDU_NDIS_802_11_LENGTH_SSID - 1] of uchar; // SSID information field
  end;

  Pndu_NDIS_WLAN_BSSID = ^Tndu_NDIS_WLAN_BSSID;

  Tndu_NDIS_WLAN_BSSID = record
    Length: ulong;                              // Length of this structure
    MacAddress: Tndu_NDIS_802_11_MAC_ADDRESS;   // BSSID
    Reserved: array[0..1] of uchar;
    Ssid: Tndu_NDIS_802_11_SSID;                // SSID
    Privacy: ulong;                              // WEP encryption requirement
    Rssi: Tndu_NDIS_802_11_RSSI;                // receive signal
    // strength in dBm
    NetworkTypeInUse: Tndu_NDIS_802_11_NETWORK_TYPE;
    Configuration: Tndu_NDIS_802_11_CONFIGURATION;
    InfrastructureMode: Tndu_NDIS_802_11_NETWORK_INFRASTRUCTURE;
    SupportedRates: Tndu_NDIS_802_11_RATES;
  end;

  Pndu_NDIS_802_11_BSSID_LIST = ^Tndu_NDIS_802_11_BSSID_LIST;

  Tndu_NDIS_802_11_BSSID_LIST = record
    NumberOfItems: ulong;                        // in list below, at least 1
    Bssid: array[0..0] of Tndu_NDIS_WLAN_BSSID;
  end;

  // Added Capabilities, IELength and IEs for each BSSID
  Pndu_NDIS_WLAN_BSSID_EX = ^Tndu_NDIS_WLAN_BSSID_EX;

  Tndu_NDIS_WLAN_BSSID_EX = record
    Length: ulong;                              // Length of this structure
    MacAddress: Tndu_NDIS_802_11_MAC_ADDRESS;    // BSSID
    Reserved: array[0..1] of uchar;
    Ssid: Tndu_NDIS_802_11_SSID;                // SSID
    Privacy: ulong;                              // WEP encryption requirement
    Rssi: Tndu_NDIS_802_11_RSSI;                // receive signal
    // strength in dBm
    NetworkTypeInUse: Tndu_NDIS_802_11_NETWORK_TYPE;
    Configuration: Tndu_NDIS_802_11_CONFIGURATION;
    InfrastructureMode: Tndu_NDIS_802_11_NETWORK_INFRASTRUCTURE;
    SupportedRates: Tndu_NDIS_802_11_RATES_EX;
    IELength: ulong;
    IEs: array[0..0] of uchar;
  end;

  Pndu_NDIS_802_11_BSSID_LIST_EX = ^Tndu_NDIS_802_11_BSSID_LIST_EX;

  Tndu_NDIS_802_11_BSSID_LIST_EX = record
    NumberOfItems: ulong;                        // in list below, at least 1
    Bssid: array[0..0] of Tndu_NDIS_WLAN_BSSID_EX;
  end;

  Pndu_NDIS_802_11_FIXED_IEs = ^Tndu_NDIS_802_11_FIXED_IEs;

  Tndu_NDIS_802_11_FIXED_IEs = record
    Timestamp: array[0..7] of uchar;
    BeaconInterval: ushort;
    Capabilities: ushort;
  end;

  Pndu_NDIS_802_11_VARIABLE_IEs = ^Tndu_NDIS_802_11_VARIABLE_IEs;

  Tndu_NDIS_802_11_VARIABLE_IEs = record
    ElementID: uchar;
    Length: uchar;                              // Number of bytes in data field
    Data: array[0..0] of uchar;
  end;

  Tndu_NDIS_802_11_FRAGMENTATION_THRESHOLD = ulong;

  Tndu_NDIS_802_11_RTS_THRESHOLD = ulong;

  Tndu_NDIS_802_11_ANTENNA = ulong;

  Pndu_NDIS_802_11_PRIVACY_FILTER = ^Tndu_NDIS_802_11_PRIVACY_FILTER;
  Tndu_NDIS_802_11_PRIVACY_FILTER = (
    Ndis802_11PrivFilterAcceptAll,
    Ndis802_11PrivFilter8021xWEP
    );

  // Added new encryption types
  // Also aliased typedef to new name
  Pndu_NDIS_802_11_WEP_STATUS = ^Tndu_NDIS_802_11_WEP_STATUS;
  Tndu_NDIS_802_11_WEP_STATUS = (
    Ndis802_11WEPEnabled,
    Ndis802_11Encryption1Enabled = Ndis802_11WEPEnabled,
    Ndis802_11WEPDisabled,
    Ndis802_11EncryptionDisabled = Ndis802_11WEPDisabled,
    Ndis802_11WEPKeyAbsent,
    Ndis802_11Encryption1KeyAbsent = Ndis802_11WEPKeyAbsent,
    Ndis802_11WEPNotSupported,
    Ndis802_11EncryptionNotSupported = Ndis802_11WEPNotSupported,
    Ndis802_11Encryption2Enabled,
    Ndis802_11Encryption2KeyAbsent,
    Ndis802_11Encryption3Enabled,
    Ndis802_11Encryption3KeyAbsent
    );

  Pndu_NDIS_802_11_ENCRYPTION_STATUS = ^Tndu_NDIS_802_11_ENCRYPTION_STATUS;
  Tndu_NDIS_802_11_ENCRYPTION_STATUS = Tndu_NDIS_802_11_WEP_STATUS;

  Pndu_NDIS_802_11_RELOAD_DEFAULTS = ^Tndu_NDIS_802_11_RELOAD_DEFAULTS;
  Tndu_NDIS_802_11_RELOAD_DEFAULTS = (
    Ndis802_11ReloadWEPKeys
    );

const
  NDU_NDIS_802_11_AI_REQFI_CAPABILITIES = 1;
  NDU_NDIS_802_11_AI_REQFI_LISTENINTERVAL = 2;
  NDU_NDIS_802_11_AI_REQFI_CURRENTAPADDRESS = 4;

  NDU_NDIS_802_11_AI_RESFI_CAPABILITIES = 1;
  NDU_NDIS_802_11_AI_RESFI_STATUSCODE = 2;
  NDU_NDIS_802_11_AI_RESFI_ASSOCIATIONID = 4;

type
  Pndu_NDIS_802_11_AI_REQFI = ^Tndu_NDIS_802_11_AI_REQFI;

  Tndu_NDIS_802_11_AI_REQFI = record
    Capabilities: ushort;
    ListenInterval: ushort;
    CurrentAPAddress: Tndu_NDIS_802_11_MAC_ADDRESS;
  end;

  Pndu_NDIS_802_11_AI_RESFI = ^Tndu_NDIS_802_11_AI_RESFI;

  Tndu_NDIS_802_11_AI_RESFI = record
    Capabilities: ushort;
    StatusCode: ushort;
    AssociationId: ushort;
  end;

  Pndu_NDIS_802_11_ASSOCIATION_INFORMATION = ^Tndu_NDIS_802_11_ASSOCIATION_INFORMATION;

  Tndu_NDIS_802_11_ASSOCIATION_INFORMATION = record
    Length: ulong;
    AvailableRequestFixedIEs: ushort;
    RequestFixedIEs: Tndu_NDIS_802_11_AI_REQFI;
    RequestIELength: ulong;
    OffsetRequestIEs: ulong;
    AvailableResponseFixedIEs: ushort;
    ResponseFixedIEs: Tndu_NDIS_802_11_AI_RESFI;
    ResponseIELength: ulong;
    OffsetResponseIEs: ulong;
  end;

  Pndu_NDIS_802_11_AUTHENTICATION_EVENT = ^Tndu_NDIS_802_11_AUTHENTICATION_EVENT;

  Tndu_NDIS_802_11_AUTHENTICATION_EVENT = record
    Status: Tndu_NDIS_802_11_STATUS_INDICATION;
    Request: array[0..0] of Tndu_NDIS_802_11_AUTHENTICATION_REQUEST;
  end;

  Pndu_NDIS_802_11_TEST = ^Tndu_NDIS_802_11_TEST;

  Tndu_NDIS_802_11_TEST = record
    Length: ulong;
    aType: ulong;        // = Type aus C++
    case integer of
      0: (AuthenticationEvent: Tndu_NDIS_802_11_AUTHENTICATION_EVENT);
      1: (RssiTrigger: Tndu_NDIS_802_11_RSSI);
  end;

  // 802.11 Media stream constraints, associated with OID_802_11_MEDIA_STREAM_MODE
  Pndu_NDIS_802_11_MEDIA_STREAM_MODE = ^Tndu_NDIS_802_11_MEDIA_STREAM_MODE;
  Tndu_NDIS_802_11_MEDIA_STREAM_MODE = (
    Ndis802_11MediaStreamOff,
    Ndis802_11MediaStreamOn
    );

  // PMKID Structures
  Tndu_NDIS_802_11_PMKID_VALUE = array[0..15] of uchar;

  Pndu_BSSID_INFO = ^Tndu_BSSID_INFO;

  Tndu_BSSID_INFO = record
    BSSID: Tndu_NDIS_802_11_MAC_ADDRESS;
    PMKID: Tndu_NDIS_802_11_PMKID_VALUE;
  end;

  Pndu_NDIS_802_11_PMKID = ^Tndu_NDIS_802_11_PMKID;

  Tndu_NDIS_802_11_PMKID = record
    Length: ulong;
    BSSIDInfoCount: ulong;
    BSSIDInfo: array[0..0] of Tndu_BSSID_INFO;
  end;

  Pndu_NDIS_802_11_AUTHENTICATION_ENCRYPTION =
    ^Tndu_NDIS_802_11_AUTHENTICATION_ENCRYPTION;

  Tndu_NDIS_802_11_AUTHENTICATION_ENCRYPTION = record
    AuthModeSupported: Tndu_NDIS_802_11_AUTHENTICATION_MODE;
    EncryptStatusSupported: Tndu_NDIS_802_11_ENCRYPTION_STATUS;
  end;

  Pndu_NDIS_802_11_CAPABILITY = ^Tndu_NDIS_802_11_CAPABILITY;

  Tndu_NDIS_802_11_CAPABILITY = record
    Length: ulong;
    Version: ulong;
    NoOfPMKIDs: ulong;
    NoOfAuthEncryptPairsSupported: ulong;
    AuthenticationEncryptionSupported: array[0..0] of
    Tndu_NDIS_802_11_AUTHENTICATION_ENCRYPTION;
  end;

  Pndu_NDIS_802_11_NON_BCAST_SSID_LIST = ^Tndu_NDIS_802_11_NON_BCAST_SSID_LIST;

  Tndu_NDIS_802_11_NON_BCAST_SSID_LIST = record
    NumberOfItems: ulong;
    Non_Bcast_Ssid: array[0..0] of Tndu_NDIS_802_11_SSID;
  end;

  // for OID_802_11_RADIO_STATUS
  Pndu_NDIS_802_11_RADIO_STATUS = ^Tndu_NDIS_802_11_RADIO_STATUS;
  Tndu_NDIS_802_11_RADIO_STATUS = (
    Ndis802_11RadioStatusOn,
    Ndis802_11RadioStatusHardwareOff,
    Ndis802_11RadioStatusSoftwareOff,
    Ndis802_11RadioStatusHardwareSoftwareOff,
    Ndis802_11RadioStatusMax      // not a real mode, defined as an upper bound
    );

const

  // IRDA objects


  NDU_OID_IRDA_RECEIVING = $0A010100;
  NDU_OID_IRDA_TURNAROUND_TIME = $0A010101;
  NDU_OID_IRDA_SUPPORTED_SPEEDS = $0A010102;
  NDU_OID_IRDA_LINK_SPEED = $0A010103;
  NDU_OID_IRDA_MEDIA_BUSY = $0A010104;

  NDU_OID_IRDA_EXTRA_RCV_BOFS = $0A010200;
  NDU_OID_IRDA_RATE_SNIFF = $0A010201;
  NDU_OID_IRDA_UNICAST_LIST = $0A010202;
  NDU_OID_IRDA_MAX_UNICAST_LIST_SIZE = $0A010203;
  NDU_OID_IRDA_MAX_RECEIVE_WINDOW_SIZE = $0A010204;
  NDU_OID_IRDA_MAX_SEND_WINDOW_SIZE = $0A010205;
  NDU_OID_IRDA_RESERVED1 = $0A01020A;  // The range between OID_IRDA_RESERVED1
  NDU_OID_IRDA_RESERVED2 = $0A01020F;  // and OID_IRDA_RESERVED2 is reserved


  // IEEE1394 mandatory general OIDs.


  NDU_OID_1394_LOCAL_NODE_INFO = $0C010101;
  NDU_OID_1394_VC_INFO = $0C010102;


  // The following OIDs are not specific to a media.



  // These are objects for Connection-oriented media call-managers.


  NDU_OID_CO_ADD_PVC = $FE000001;
  NDU_OID_CO_DELETE_PVC = $FE000002;
  NDU_OID_CO_GET_CALL_INFORMATION = $FE000003;
  NDU_OID_CO_ADD_ADDRESS = $FE000004;
  NDU_OID_CO_DELETE_ADDRESS = $FE000005;
  NDU_OID_CO_GET_ADDRESSES = $FE000006;
  NDU_OID_CO_ADDRESS_CHANGE = $FE000007;
  NDU_OID_CO_SIGNALING_ENABLED = $FE000008;
  NDU_OID_CO_SIGNALING_DISABLED = $FE000009;
  NDU_OID_CO_AF_CLOSE = $FE00000A;


  // Objects for call-managers and MCMs that support TAPI access.


  NDU_OID_CO_TAPI_CM_CAPS = $FE001001;
  NDU_OID_CO_TAPI_LINE_CAPS = $FE001002;
  NDU_OID_CO_TAPI_ADDRESS_CAPS = $FE001003;
  NDU_OID_CO_TAPI_TRANSLATE_TAPI_CALLPARAMS = $FE001004;
  NDU_OID_CO_TAPI_TRANSLATE_NDIS_CALLPARAMS = $FE001005;
  NDU_OID_CO_TAPI_TRANSLATE_TAPI_SAP = $FE001006;
  NDU_OID_CO_TAPI_GET_CALL_DIAGNOSTICS = $FE001007;
  NDU_OID_CO_TAPI_REPORT_DIGITS = $FE001008;
  NDU_OID_CO_TAPI_DONT_REPORT_DIGITS = $FE001009;


  //  PnP and PM OIDs


  NDU_OID_PNP_CAPABILITIES = $FD010100;
  NDU_OID_PNP_SET_POWER = $FD010101;
  NDU_OID_PNP_QUERY_POWER = $FD010102;
  NDU_OID_PNP_ADD_WAKE_UP_PATTERN = $FD010103;
  NDU_OID_PNP_REMOVE_WAKE_UP_PATTERN = $FD010104;
  NDU_OID_PNP_WAKE_UP_PATTERN_LIST = $FD010105;
  NDU_OID_PNP_ENABLE_WAKE_UP = $FD010106;


  //  PnP/PM Statistics (Optional).


  NDU_OID_PNP_WAKE_UP_OK = $FD020200;
  NDU_OID_PNP_WAKE_UP_ERROR = $FD020201;


  //  The following bits are defined for OID_PNP_ENABLE_WAKE_UP


  NDU_NDIS_PNP_WAKE_UP_MAGIC_PACKET = $00000001;
  NDU_NDIS_PNP_WAKE_UP_PATTERN_MATCH = $00000002;
  NDU_NDIS_PNP_WAKE_UP_LINK_CHANGE = $00000004;


  //  TCP/IP OIDs


  NDU_OID_TCP_TASK_OFFLOAD = $FC010201;
  NDU_OID_TCP_TASK_IPSEC_ADD_SA = $FC010202;
  NDU_OID_TCP_TASK_IPSEC_DELETE_SA = $FC010203;
  NDU_OID_TCP_SAN_SUPPORT = $FC010204;
  NDU_OID_TCP_TASK_IPSEC_ADD_UDPESP_SA = $FC010205;
  NDU_OID_TCP_TASK_IPSEC_DELETE_UDPESP_SA = $FC010206;
  NDU_OID_TCP4_OFFLOAD_STATS = $FC010207;
  NDU_OID_TCP6_OFFLOAD_STATS = $FC010208;
  NDU_OID_IP4_OFFLOAD_STATS = $FC010209;
  NDU_OID_IP6_OFFLOAD_STATS = $FC01020A;

  // new offload OIDs for NDIS 6

  NDU_OID_TCP_OFFLOAD_CURRENT_CONFIG = $FC01020B;
  // query only, handled by NDIS
  NDU_OID_TCP_OFFLOAD_PARAMETERS = $FC01020C;          // set only
  NDU_OID_TCP_OFFLOAD_HARDWARE_CAPABILITIES = $FC01020D;          // query only
  NDU_OID_TCP_CONNECTION_OFFLOAD_CURRENT_CONFIG = $FC01020E;      // query only
  NDU_OID_TCP_CONNECTION_OFFLOAD_HARDWARE_CAPABILITIES = $FC01020F; // query only
  NDU_OID_OFFLOAD_ENCAPSULATION = $0101010A;


  //  Defines for FFP, obsolete


  NDU_OID_FFP_SUPPORT = $FC010210;
  NDU_OID_FFP_FLUSH = $FC010211;
  NDU_OID_FFP_CONTROL = $FC010212;
  NDU_OID_FFP_PARAMS = $FC010213;
  NDU_OID_FFP_DATA = $FC010214;

  NDU_OID_FFP_DRIVER_STATS = $FC020210;
  NDU_OID_FFP_ADAPTER_STATS = $FC020211;


  // TCP Connection offload OID


  NDU_OID_TCP_CONNECTION_OFFLOAD_PARAMETERS = $FC030201;


  //  Defines for QOS


  NDU_OID_QOS_RESERVED1 = $FB010100;
  NDU_OID_QOS_RESERVED2 = $FB010101;
  NDU_OID_QOS_RESERVED3 = $FB010102;
  NDU_OID_QOS_RESERVED4 = $FB010103;
  NDU_OID_QOS_RESERVED5 = $FB010104;
  NDU_OID_QOS_RESERVED6 = $FB010105;
  NDU_OID_QOS_RESERVED7 = $FB010106;
  NDU_OID_QOS_RESERVED8 = $FB010107;
  NDU_OID_QOS_RESERVED9 = $FB010108;
  NDU_OID_QOS_RESERVED10 = $FB010109;
  NDU_OID_QOS_RESERVED11 = $FB01010A;
  NDU_OID_QOS_RESERVED12 = $FB01010B;
  NDU_OID_QOS_RESERVED13 = $FB01010C;
  NDU_OID_QOS_RESERVED14 = $FB01010D;
  NDU_OID_QOS_RESERVED15 = $FB01010E;
  NDU_OID_QOS_RESERVED16 = $FB01010F;
  NDU_OID_QOS_RESERVED17 = $FB010110;
  NDU_OID_QOS_RESERVED18 = $FB010111;
  NDU_OID_QOS_RESERVED19 = $FB010112;
  NDU_OID_QOS_RESERVED20 = $FB010113;


// NDIS Proxy OID_GEN_CO_DEVICE_PROFILE structure. The optional OID and
// this structure is a generic means of describing a CO device's
// capabilites, and is used by the NDIS Proxy to construct a TAPI device
// capabilities structure.

type
  Pndu_NDIS_CO_DEVICE_PROFILE = ^Tndu_NDIS_CO_DEVICE_PROFILE;

  Tndu_NDIS_CO_DEVICE_PROFILE = record
    DeviceDescription: Tndu_NDIS_VAR_DATA_DESC;  // e.g. 'GigabitATMNet'
    DevSpecificInfo: Tndu_NDIS_VAR_DATA_DESC;    // special features

    ulTAPISupplementaryPassThru: ulong;          // reserved in NT5
    ulAddressModes: ulong;
    ulNumAddresses: ulong;
    ulBearerModes: ulong;
    ulMaxTxRate: ulong;                          // bytes per second
    ulMinTxRate: ulong;                         // bytes per second
    ulMaxRxRate: ulong;                         // bytes per second
    ulMinRxRate: ulong;                         // bytes per second
    ulMediaModes: ulong;


    // Tone/digit generation and recognition capabilities

    ulGenerateToneModes: ulong;
    ulGenerateToneMaxNumFreq: ulong;
    ulGenerateDigitModes: ulong;
    ulMonitorToneMaxNumFreq: ulong;
    ulMonitorToneMaxNumEntries: ulong;
    ulMonitorDigitModes: ulong;
    ulGatherDigitsMinTimeout: ulong;            // milliseconds
    ulGatherDigitsMaxTimeout: ulong;            // milliseconds

    ulDevCapFlags: ulong;                        // Misc. capabilities
    ulMaxNumActiveCalls: ulong;
    // (This * ulMinRate) = total bandwidth (which may equal ulMaxRate)
    ulAnswerMode: ulong;                        // Effect of answering a new call when an
    // existing call is non-idle

    // User-User info sizes allowed to accompany each operation


    ulUUIAcceptSize: ulong;                      // bytes
    ulUUIAnswerSize: ulong;                     // bytes
    ulUUIMakeCallSize: ulong;                    // bytes
    ulUUIDropSize: ulong;                        // bytes
    ulUUISendUserUserInfoSize: ulong;            // bytes
    ulUUICallInfoSize: ulong;                   // bytes
  end;


  //  Structures for TCP IPsec.


  Tndu_IPMask = ulong;
  Tndu_IPAddr = ulong;

  Tndu_SPI_TYPE = ulong;

  Tndu_OFFLOAD_OPERATION_E = (
    AUTHENTICATE = 1,
    ENCRYPT
    );

  Pndu_OFFLOAD_ALGO_INFO = ^Tndu_OFFLOAD_ALGO_INFO;

  Tndu_OFFLOAD_ALGO_INFO = record
    algoIdentifier: ulong;
    algoKeylen: ulong;
    algoRounds: ulong;
  end;

  Tndu_OFFLOAD_CONF_ALGO = (
    OFFLOAD_IPSEC_CONF_NONE,
    OFFLOAD_IPSEC_CONF_DES,
    OFFLOAD_IPSEC_CONF_RESERVED,
    OFFLOAD_IPSEC_CONF_3_DES,
    OFFLOAD_IPSEC_CONF_MAX
    );

  Tndu_OFFLOAD_INTEGRITY_ALGO = (
    OFFLOAD_IPSEC_INTEGRITY_NONE,
    OFFLOAD_IPSEC_INTEGRITY_MD5,
    OFFLOAD_IPSEC_INTEGRITY_SHA,
    OFFLOAD_IPSEC_INTEGRITY_MAX
    );

  Pndu_OFFLOAD_SECURITY_ASSOCIATION = ^Tndu_OFFLOAD_SECURITY_ASSOCIATION;

  Tndu_OFFLOAD_SECURITY_ASSOCIATION = record
    Operation: Tndu_OFFLOAD_OPERATION_E;
    SPI: Tndu_SPI_TYPE;
    IntegrityAlgo: Tndu_OFFLOAD_ALGO_INFO;
    ConfAlgo: Tndu_OFFLOAD_ALGO_INFO;
    Reserved: Tndu_OFFLOAD_ALGO_INFO;
  end;

const
  NDU_OFFLOAD_MAX_SAS = 3;
  NDU_OFFLOAD_INBOUND_SA = $0001;
  NDU_OFFLOAD_OUTBOUND_SA = $0002;

type
  Pndu_OFFLOAD_IPSEC_ADD_SA = ^Tndu_OFFLOAD_IPSEC_ADD_SA;

  Tndu_OFFLOAD_IPSEC_ADD_SA = record
    SrcAddr: Tndu_IPAddr;
    SrcMask: Tndu_IPMask;
    DestAddr: Tndu_IPAddr;
    DestMask: Tndu_IPMask;
    Protocol: ulong;
    SrcPort: ushort;
    DestPort: ushort;
    SrcTunnelAddr: Tndu_IPAddr;
    DestTunnelAddr: Tndu_IPAddr;
    Flags: ushort;
    NumSAs: short;
    SecAssoc: array[0..NDU_OFFLOAD_MAX_SAS - 1] of Tndu_OFFLOAD_SECURITY_ASSOCIATION;
    OffloadHandle: Handle;
    KeyLen: ulong;
    KeyMat: array[0..0] of uchar;
  end;

  Pndu_OFFLOAD_IPSEC_DELETE_SA = ^Tndu_OFFLOAD_IPSEC_DELETE_SA;

  Tndu_OFFLOAD_IPSEC_DELETE_SA = record
    OffloadHandle: Handle;
  end;

  Pndu_UDP_ENCAP_TYPE = ^Tndu_UDP_ENCAP_TYPE;
  Tndu_UDP_ENCAP_TYPE = (
    OFFLOAD_IPSEC_UDPESP_ENCAPTYPE_IKE,
    OFFLOAD_IPSEC_UDPESP_ENCAPTYPE_OTHER
    );

  Pndu_OFFLOAD_IPSEC_UDPESP_ENCAPTYPE_ENTRY = ^Tndu_OFFLOAD_IPSEC_UDPESP_ENCAPTYPE_ENTRY;

  Tndu_OFFLOAD_IPSEC_UDPESP_ENCAPTYPE_ENTRY = record
    UdpEncapType: Tndu_UDP_ENCAP_TYPE;
    DstEncapPort: ushort;
  end;

  Pndu_OFFLOAD_IPSEC_ADD_UDPESP_SA = ^Tndu_OFFLOAD_IPSEC_ADD_UDPESP_SA;

  Tndu_OFFLOAD_IPSEC_ADD_UDPESP_SA = record
    SrcAddr: Tndu_IPAddr;
    SrcMask: Tndu_IPMask;
    DstAddr: Tndu_IPAddr;
    DstMask: Tndu_IPMask;
    Protocol: ulong;
    SrcPort: ushort;
    DstPort: ushort;
    SrcTunnelAddr: Tndu_IPAddr;
    DstTunnelAddr: Tndu_IPAddr;
    Flags: ushort;
    NumSAs: short;
    SecAssoc: array[0..NDU_OFFLOAD_MAX_SAS] of Tndu_OFFLOAD_SECURITY_ASSOCIATION;
    OffloadHandle: Handle;
    EncapTypeEntry: Tndu_OFFLOAD_IPSEC_UDPESP_ENCAPTYPE_ENTRY;
    EncapTypeEntryOffldHandle: Handle;
    KeyLen: ulong;
    KeyMat: array[0..0] of uchar;
  end;

  Pndu_OFFLOAD_IPSEC_DELETE_UDPESP_SA = ^Tndu_OFFLOAD_IPSEC_DELETE_UDPESP_SA;

  Tndu_OFFLOAD_IPSEC_DELETE_UDPESP_SA = record
    OffloadHandle: Handle;
    EncapTypeEntryOffldHandle: Handle;
  end;


  // Type to go with OID_GEN_VLAN_ID: the least significant 12 bits are
  // used as the VLAN ID (VID) per IEEE 802.1Q. Higher order bits are
  // reserved and must be set to 0.


  Tndu_NDIS_VLAN_ID = ulong;


  // Medium the Ndis Driver is running on (OID_GEN_MEDIA_SUPPORTED/ OID_GEN_MEDIA_IN_USE).


  Pndu_NDIS_MEDIUM = ^Tndu_NDIS_MEDIUM;
  Tndu_NDIS_MEDIUM = (
    NdisMedium802_3,
    NdisMedium802_5,
    NdisMediumFddi,
    NdisMediumWan,
    NdisMediumLocalTalk,
    NdisMediumDix,              // defined for convenience, not a real medium
    NdisMediumArcnetRaw,
    NdisMediumArcnet878_2,
    NdisMediumAtm,
    NdisMediumWirelessWan,
    NdisMediumIrda,
    NdisMediumBpc,
    NdisMediumCoWan,
    NdisMedium1394,
    NdisMediumInfiniBand,
    NdisMediumTunnel,
    NdisMediumNative802_11,
    NdisMediumLoopback,
    NdisMediumMax               // Not a real medium, defined as an upper-bound
    );


  // Physical Medium Type definitions. Used with OID_GEN_PHYSICAL_MEDIUM.


  Pndu_NDIS_PHYSICAL_MEDIUM = ^Tndu_NDIS_PHYSICAL_MEDIUM;
  Tndu_NDIS_PHYSICAL_MEDIUM = (
    NdisPhysicalMediumUnspecified,
    NdisPhysicalMediumWirelessLan,
    NdisPhysicalMediumCableModem,
    NdisPhysicalMediumPhoneLine,
    NdisPhysicalMediumPowerLine,
    NdisPhysicalMediumDSL,      // includes ADSL and UADSL (G.Lite)
    NdisPhysicalMediumFibreChannel,
    NdisPhysicalMedium1394,
    NdisPhysicalMediumWirelessWan,
    NdisPhysicalMediumNative802_11,
    NdisPhysicalMediumBluetooth,
    NdisPhysicalMediumInfiniband,
    NdisPhysicalMediumWiMax,
    NdisPhysicalMediumUWB,
    NdisPhysicalMedium802_3,
    NdisPhysicalMedium802_5,
    NdisPhysicalMediumIrda,
    NdisPhysicalMediumWiredWAN,
    NdisPhysicalMediumWiredCoWan,
    NdisPhysicalMediumOther,
    NdisPhysicalMediumMax       // Not a real physical type, defined as an upper-bound
    );


//  Protocol types supported by ndis. These values need to be consistent with ADDRESS_TYPE_XXX defined in TDI.H


const
  NDU_NDIS_PROTOCOL_ID_DEFAULT = $00;
  NDU_NDIS_PROTOCOL_ID_TCP_IP = $02;
  NDU_NDIS_PROTOCOL_ID_IPX = $06;
  NDU_NDIS_PROTOCOL_ID_NBF = $07;
  NDU_NDIS_PROTOCOL_ID_MAX = $0F;
  NDU_NDIS_PROTOCOL_ID_MASK = $0F;


// The following is used with OID_GEN_TRANSPORT_HEADER_OFFSET to indicate the length of the layer-2 header
// for packets sent by a particular protocol.


type
  Pndu_TRANSPORT_HEADER_OFFSET = ^Tndu_TRANSPORT_HEADER_OFFSET;

  Tndu_TRANSPORT_HEADER_OFFSET = record
    ProtocolType: ushort;
    // The protocol that is sending this OID (NDIS_PROTOCOL_ID_XXX above)
    HeaderOffset: ushort; // The header offset
  end;


  // The structures below need to be consistent with TRANSPORT_ADDRESS structures in TDI.H


  Pndu_NETWORK_ADDRESS = ^Tndu_NETWORK_ADDRESS;

  Tndu_NETWORK_ADDRESS = record
    AddressLength: ushort;          // length in bytes of Address[] in this
    AddressType: ushort;            // type of this address (NDIS_PROTOCOL_ID_XXX above)
    Address: array[0..0] of uchar;  // actually AddressLength bytes long
  end;


  // The following is used with OID_GEN_NETWORK_LAYER_ADDRESSES to set network layer addresses on an interface


  Pndu_NETWORK_ADDRESS_LIST = ^Tndu_NETWORK_ADDRESS_LIST;

  Tndu_NETWORK_ADDRESS_LIST = record
    AddressCount: long;              // number of addresses following
    AddressType: ushort;            // type of this address (NDIS_PROTOCOL_ID_XXX above)
    Address: array[0..0] of Tndu_NETWORK_ADDRESS; // actually AddressCount elements long
  end;


  // IP address - This must remain consistent with TDI_ADDRESS_IP in tdi.h


  Pndu_NETWORK_ADDRESS_IP = ^Tndu_NETWORK_ADDRESS_IP;

  Tndu_NETWORK_ADDRESS_IP = record
    sin_port: ushort;
    in_addr: ulong;
    sin_zero: array[0..7] of uchar;
  end;

const
  NDU_NETWORK_ADDRESS_LENGTH_IP = SizeOf(Tndu_NETWORK_ADDRESS_IP);

type

  // IPX address - This must remain consistent with TDI_ADDRESS_IPX in tdi.h.


  Pndu_NETWORK_ADDRESS_IPX = ^Tndu_NETWORK_ADDRESS_IPX;

  Tndu_NETWORK_ADDRESS_IPX = record
    NetworkAddress: ulong;
    NodeAddress: array[0..5] of uchar;
    Socket: ushort;
  end;

const
  NDU_NETWORK_ADDRESS_LENGTH_IPX = SizeOf(Tndu_NETWORK_ADDRESS_IPX);


// Hardware status codes (OID_GEN_HARDWARE_STATUS).


type
  Pndu_NDIS_HARDWARE_STATUS = ^Tndu_NDIS_HARDWARE_STATUS;
  Tndu_NDIS_HARDWARE_STATUS = (
    NdisHardwareStatusReady,
    NdisHardwareStatusInitializing,
    NdisHardwareStatusReset,
    NdisHardwareStatusClosing,
    NdisHardwareStatusNotReady
    );


  // this is the type passed in the OID_GEN_GET_TIME_CAPS request

  Pndu_GEN_GET_TIME_CAPS = ^Tndu_GEN_GET_TIME_CAPS;

  Tndu_GEN_GET_TIME_CAPS = record
    Flags: ulong;    // Bits defined below
    ClockPrecision: ulong;
  end;

const
  NDU_READABLE_LOCAL_CLOCK = $00000001;
  NDU_CLOCK_NETWORK_DERIVED = $00000002;
  NDU_CLOCK_PRECISION = $00000004;
  NDU_RECEIVE_TIME_INDICATION_CAPABLE = $00000008;
  NDU_TIMED_SEND_CAPABLE = $00000010;
  NDU_TIME_STAMP_CAPABLE = $00000020;


// this is the type passed in the OID_GEN_GET_NETCARD_TIME request

type
  Pndu_GEN_GET_NETCARD_TIME = ^Tndu_GEN_GET_NETCARD_TIME;

  Tndu_GEN_GET_NETCARD_TIME = record
    ReadTime: ulonglong;
  end;


  //  NDIS PnP routines and definitions.

  Pndu_NDIS_PM_PACKET_PATTERN = ^Tndu_NDIS_PM_PACKET_PATTERN;

  Tndu_NDIS_PM_PACKET_PATTERN = record
    Priority: ulong;                // Importance of the given pattern.
    Reserved: ulong;                // Context information for transports.
    MaskSize: ulong;                // Size in bytes of the pattern mask.
    PatternOffset: ulong;            // Offset from beginning of this
    // structure to the pattern bytes.
    PatternSize: ulong;              // Size in bytes of the pattern.
    PatternFlags: ulong;            // Flags (TBD).
  end;


  //  The following structure defines the device power states.

  Pndu_NDIS_DEVICE_POWER_STATE = ^Tndu_NDIS_DEVICE_POWER_STATE;
  Tndu_NDIS_DEVICE_POWER_STATE = (
    NdisDeviceStateUnspecified = 0,
    NdisDeviceStateD0,
    NdisDeviceStateD1,
    NdisDeviceStateD2,
    NdisDeviceStateD3,
    NdisDeviceStateMaximum
    );


  //  The following structure defines the wake-up capabilities of the device.

  Pndu_NDIS_PM_WAKE_UP_CAPABILITIES = ^Tndu_NDIS_PM_WAKE_UP_CAPABILITIES;

  Tndu_NDIS_PM_WAKE_UP_CAPABILITIES = record
    MinMagicPacketWakeUp: Tndu_NDIS_DEVICE_POWER_STATE;
    MinPatternWakeUp: Tndu_NDIS_DEVICE_POWER_STATE;
    MinLinkChangeWakeUp: Tndu_NDIS_DEVICE_POWER_STATE;
  end;


// the following flags define the -enabled- wake-up capabilities of the device
// passed in the Flags field of NDIS_PNP_CAPABILITIES structure


const
  NDU_NDIS_DEVICE_WAKE_UP_ENABLE = $00000001;
  NDU_NDIS_DEVICE_WAKE_ON_PATTERN_MATCH_ENABLE = $00000002;
  NDU_NDIS_DEVICE_WAKE_ON_MAGIC_PACKET_ENABLE = $00000004;


//  This structure defines general PnP capabilities of the miniport driver.

type
  Pndu_NDIS_PNP_CAPABILITIES = ^Tndu_NDIS_PNP_CAPABILITIES;

  Tndu_NDIS_PNP_CAPABILITIES = record
    Flags: ulong;
    WakeUpCapabilities: Tndu_NDIS_PM_WAKE_UP_CAPABILITIES;
  end;


  // Defines the attachment types for FDDI (OID_FDDI_ATTACHMENT_TYPE).

  Pndu_NDIS_FDDI_ATTACHMENT_TYPE = ^Tndu_NDIS_FDDI_ATTACHMENT_TYPE;
  Tndu_NDIS_FDDI_ATTACHMENT_TYPE = (
    NdisFddiTypeIsolated = 1,
    NdisFddiTypeLocalA,
    NdisFddiTypeLocalB,
    NdisFddiTypeLocalAB,
    NdisFddiTypeLocalS,
    NdisFddiTypeWrapA,
    NdisFddiTypeWrapB,
    NdisFddiTypeWrapAB,
    NdisFddiTypeWrapS,
    NdisFddiTypeCWrapA,
    NdisFddiTypeCWrapB,
    NdisFddiTypeCWrapS,
    NdisFddiTypeThrough
    );


  // Defines the ring management states for FDDI (OID_FDDI_RING_MGT_STATE).

  Pndu_NDIS_FDDI_RING_MGT_STATE = ^Tndu_NDIS_FDDI_RING_MGT_STATE;
  Tndu_NDIS_FDDI_RING_MGT_STATE = (
    NdisFddiRingIsolated = 1,
    NdisFddiRingNonOperational,
    NdisFddiRingOperational,
    NdisFddiRingDetect,
    NdisFddiRingNonOperationalDup,
    NdisFddiRingOperationalDup,
    NdisFddiRingDirected,
    NdisFddiRingTrace
    );


  // Defines the Lconnection state for FDDI (OID_FDDI_LCONNECTION_STATE).

  Pndu_NDIS_FDDI_LCONNECTION_STATE = ^Tndu_NDIS_FDDI_LCONNECTION_STATE;
  Tndu_NDIS_FDDI_LCONNECTION_STATE = (
    NdisFddiStateOff = 1,
    NdisFddiStateBreak,
    NdisFddiStateTrace,
    NdisFddiStateConnect,
    NdisFddiStateNext,
    NdisFddiStateSignal,
    NdisFddiStateJoin,
    NdisFddiStateVerify,
    NdisFddiStateActive,
    NdisFddiStateMaintenance
    );


  // Defines the medium subtypes for WAN medium (OID_WAN_MEDIUM_SUBTYPE).
  // Sub-medium used only by connection-oriented WAN devices
  // i.e. NdisMediumWan, NdisMediumCoWan.

  Pndu_NDIS_WAN_MEDIUM_SUBTYPE = ^Tndu_NDIS_WAN_MEDIUM_SUBTYPE;
  Tndu_NDIS_WAN_MEDIUM_SUBTYPE = (
    NdisWanMediumHub,
    NdisWanMediumX_25,
    NdisWanMediumIsdn,
    NdisWanMediumSerial,
    NdisWanMediumFrameRelay,
    NdisWanMediumAtm,
    NdisWanMediumSonet,
    NdisWanMediumSW56K,
    NdisWanMediumPPTP,
    NdisWanMediumL2TP,
    NdisWanMediumIrda,
    NdisWanMediumParallel,
    NdisWanMediumPppoe
    );


  // Defines the header format for WAN medium (OID_WAN_HEADER_FORMAT).

  Pndu_NDIS_WAN_HEADER_FORMAT = ^Tndu_NDIS_WAN_HEADER_FORMAT;
  Tndu_NDIS_WAN_HEADER_FORMAT = (
    NdisWanHeaderNative,        // src/dest based on subtype, followed by NLPID
    NdisWanHeaderEthernet       // emulation of ethernet header
    );


  // Defines the line quality on a WAN line (OID_WAN_QUALITY_OF_SERVICE).

  Pndu_NDIS_WAN_QUALITY = ^Tndu_NDIS_WAN_QUALITY;
  Tndu_NDIS_WAN_QUALITY = (
    NdisWanRaw,
    NdisWanErrorControl,
    NdisWanReliable
    );


  // Defines a protocol's WAN specific capabilities (OID_WAN_PROTOCOL_CAPS).

  Pndu_NDIS_WAN_PROTOCOL_CAPS = ^Tndu_NDIS_WAN_PROTOCOL_CAPS;

  Tndu_NDIS_WAN_PROTOCOL_CAPS = record
    Flags: ulong;
    Reserved: ulong;
  end;


// Flags used in NDIS_WAN_PROTOCOL_CAPS

const
  NDU_WAN_PROTOCOL_KEEPS_STATS = $00000001;


// Defines the state of a token-ring adapter (OID_802_5_CURRENT_RING_STATE).


type
  Pndu_NDIS_802_5_RING_STATE = ^Tndu_NDIS_802_5_RING_STATE;
  Tndu_NDIS_802_5_RING_STATE = (
    NdisRingStateOpened = 1,
    NdisRingStateClosed,
    NdisRingStateOpening,
    NdisRingStateClosing,
    NdisRingStateOpenFailure,
    NdisRingStateRingFailure
    );


  // Defines the state of the LAN media

  Pndu_NDIS_MEDIA_STATE = ^Tndu_NDIS_MEDIA_STATE;
  Tndu_NDIS_MEDIA_STATE = (
    NdisMediaStateConnected,
    NdisMediaStateDisconnected
    );


  // The following is set on a per-packet basis as OOB data with NdisClass802_3Priority

  Tndu_Priority_802_3 = ulong;      // 0-7 priority levels


  //  The following structure is used to query OID_GEN_CO_LINK_SPEED and
  //  OID_GEN_CO_MINIMUM_LINK_SPEED. The first OID will return the current
  //  link speed of the adapter. The second will return the minimum link speed
  //  the adapter is capable of.

  Pndu_NDIS_CO_LINK_SPEED = ^Tndu_NDIS_CO_LINK_SPEED;

  Tndu_NDIS_CO_LINK_SPEED = record
    Outbound: ulong;
    Inbound: ulong;
  end;


  // The following structure is used in OID_GEN_LINK_SPEED_EX for interfaces
  // and is expressed in bits per second.

  Pndu_NDIS_LINK_SPEED = ^Tndu_NDIS_LINK_SPEED;

  Tndu_NDIS_LINK_SPEED = record
    XmitLinkSpeed: ulong64;
    RcvLinkSpeed: ulong64;
  end;

  // miniports or interfaces that do not know their current link speed
  // can report NDIS_LINK_SPEED_UNKNOWN == ((ULONG64)-1)
  //const
  //NDU_NET_IF_LINK_SPEED_UNKNOWN =

  Pndu_NDIS_STATUS = ^Tndu_NDIS_STATUS;
  Tndu_NDIS_STATUS = Int;


  //  Structure to be used for OID_GEN_SUPPORTED_GUIDS.
  //  This structure describes an OID to GUID mapping.
  //  Or a Status to GUID mapping.
  //  When ndis receives a request for a give GUID it will
  //  query the miniport with the supplied OID.

  Pndu_NDIS_GUID = ^Tndu_NDIS_GUID;

  Tndu_NDIS_GUID = record
    Guid: TGUID;
    union1: record
      case integer of
        0: (Oid: Tndu_NDIS_OID);
        1: (Status: Tndu_NDIS_STATUS);
    end;

    Size: ulong;         //  Size of the data element. If the GUID
    //  represents an array then this is the
    //  size of an element in the array.
    //  This is -1 for strings.
    Flags: ulong;
  end;

const
  NDU_fNDIS_GUID_TO_OID = $00000001;
  NDU_fNDIS_GUID_TO_STATUS = $00000002;
  NDU_fNDIS_GUID_ANSI_STRING = $00000004;
  NDU_fNDIS_GUID_UNICODE_STRING = $00000008;
  NDU_fNDIS_GUID_ARRAY = $00000010;
  NDU_fNDIS_GUID_ALLOW_READ = $00000020;
  NDU_fNDIS_GUID_ALLOW_WRITE = $00000040;
  NDU_fNDIS_GUID_METHOD = $00000080;
  NDU_fNDIS_GUID_NDIS_RESERVED = $00000100;
  NDU_fNDIS_GUID_SUPPORT_COMMON_HEADER = $00000200;


  // Ndis Packet Filter Bits (OID_GEN_CURRENT_PACKET_FILTER).


  NDU_NDIS_PACKET_TYPE_DIRECTED = $00000001;
  NDU_NDIS_PACKET_TYPE_MULTICAST = $00000002;
  NDU_NDIS_PACKET_TYPE_ALL_MULTICAST = $00000004;
  NDU_NDIS_PACKET_TYPE_BROADCAST = $00000008;
  NDU_NDIS_PACKET_TYPE_SOURCE_ROUTING = $00000010;
  NDU_NDIS_PACKET_TYPE_PROMISCUOUS = $00000020;
  NDU_NDIS_PACKET_TYPE_SMT = $00000040;
  NDU_NDIS_PACKET_TYPE_ALL_LOCAL = $00000080;
  NDU_NDIS_PACKET_TYPE_GROUP = $00001000;
  NDU_NDIS_PACKET_TYPE_ALL_FUNCTIONAL = $00002000;
  NDU_NDIS_PACKET_TYPE_FUNCTIONAL = $00004000;
  NDU_NDIS_PACKET_TYPE_MAC_FRAME = $00008000;
  NDU_NDIS_PACKET_TYPE_NO_LOCAL = $00010000;


  // Ndis Token-Ring Ring Status Codes (OID_802_5_CURRENT_RING_STATUS).


  NDU_NDIS_RING_SIGNAL_LOSS = $00008000;
  NDU_NDIS_RING_HARD_ERROR = $00004000;
  NDU_NDIS_RING_SOFT_ERROR = $00002000;
  NDU_NDIS_RING_TRANSMIT_BEACON = $00001000;
  NDU_NDIS_RING_LOBE_WIRE_FAULT = $00000800;
  NDU_NDIS_RING_AUTO_REMOVAL_ERROR = $00000400;
  NDU_NDIS_RING_REMOVE_RECEIVED = $00000200;
  NDU_NDIS_RING_COUNTER_OVERFLOW = $00000100;
  NDU_NDIS_RING_SINGLE_STATION = $00000080;
  NDU_NDIS_RING_RING_RECOVERY = $00000040;


  // Ndis protocol option bits (OID_GEN_PROTOCOL_OPTIONS).


  NDU_NDIS_PROT_OPTION_ESTIMATED_LENGTH = $00000001;
  NDU_NDIS_PROT_OPTION_NO_LOOPBACK = $00000002;
  NDU_NDIS_PROT_OPTION_NO_RSVD_ON_RCVPKT = $00000004;
  NDU_NDIS_PROT_OPTION_SEND_RESTRICTED = $00000008;


  // Ndis MAC option bits (OID_GEN_MAC_OPTIONS).


  NDU_NDIS_MAC_OPTION_COPY_LOOKAHEAD_DATA = $00000001;
  NDU_NDIS_MAC_OPTION_RECEIVE_SERIALIZED = $00000002;
  NDU_NDIS_MAC_OPTION_TRANSFERS_NOT_PEND = $00000004;
  NDU_NDIS_MAC_OPTION_NO_LOOPBACK = $00000008;


  // This flag has been deprecated. Deserialized drivers are
  // full duplex drivers


  NDU_NDIS_MAC_OPTION_FULL_DUPLEX = $00000010;  // deprecated

  NDU_NDIS_MAC_OPTION_EOTX_INDICATION = $00000020;
  NDU_NDIS_MAC_OPTION_8021P_PRIORITY = $00000040;
  NDU_NDIS_MAC_OPTION_SUPPORTS_MAC_ADDRESS_OVERWRITE = $00000080;
  NDU_NDIS_MAC_OPTION_RECEIVE_AT_DPC = $00000100;
  NDU_NDIS_MAC_OPTION_8021Q_VLAN = $00000200;
  NDU_NDIS_MAC_OPTION_RESERVED = $80000000;


  //  NDIS media capabilities bits (OID_GEN_MEDIA_CAPABILITIES).


  NDU_NDIS_MEDIA_CAP_TRANSMIT = $00000001;  // Supports sending data
  NDU_NDIS_MEDIA_CAP_RECEIVE = $00000002;  // Supports receiving data


  //  NDIS MAC option bits for OID_GEN_CO_MAC_OPTIONS.


  NDU_NDIS_CO_MAC_OPTION_DYNAMIC_LINK_SPEED = $00000001;


// The following is set on a per-packet basis as OOB data with NdisClassIrdaPacketInfo
// This is the per-packet info specified on a per-packet basis

type
  Pndu_NDIS_IRDA_PACKET_INFO = ^Tndu_NDIS_IRDA_PACKET_INFO;

  Tndu_NDIS_IRDA_PACKET_INFO = record
    ExtraBOFs: ulong;
    MinTurnAroundTime: ulong;
  end;

// ? :-(
{
#define NDIS_MAKE_NET_LUID(_pNetLuid, _IfType, _NetLuidIndex)       \
                                                                   \
    (_pNetLuid)->Info.IfType = _IfType;                             \
    (_pNetLuid)->Info.NetLuidIndex = _NetLuidIndex;                 \
    (_pNetLuid)->Info.Reserved = 0;                                 \
}

const
  NDU_NDIS_IF_MAX_STRING_SIZE = NDU_IF_MAX_STRING_SIZE;

type
  Pndu_NDIS_IF_COUNTED_STRING = ^Tndu_NDIS_IF_COUNTED_STRING;
  Tndu_NDIS_IF_COUNTED_STRING = Tndu_IF_COUNTED_STRING_LH;

const
  NDU_NDIS_MAX_PHYS_ADDRESS_LENGTH = NDU_IF_MAX_PHYS_ADDRESS_LENGTH;

type
  Pndu_NDIS_IF_PHYSICAL_ADDRESS = ^Tndu_NDIS_IF_PHYSICAL_ADDRESS;
  Tndu_NDIS_IF_PHYSICAL_ADDRESS = Tndu_IF_PHYSICAL_ADDRESS;


  // NDIS_MEDIA_CONNECT_STATE enum type is used in OID_GEN_MEDIA_CONNECT_STATUS_EX

  Pndu_NDIS_MEDIA_CONNECT_STATE = ^Tndu_NDIS_MEDIA_CONNECT_STATE;
  Tndu_NDIS_MEDIA_CONNECT_STATE = Tndu_NET_IF_MEDIA_CONNECT_STATE;


  // NET_IF_MEDIA_DUPLEX_STATE enum type is used in OID_GEN_MEDIA_DUPLEX_STATE

  Pndu_NDIS_MEDIA_DUPLEX_STATE = ^Tndu_NDIS_MEDIA_DUPLEX_STATE;
  Tndu_NDIS_MEDIA_DUPLEX_STATE = Tndu_NET_IF_MEDIA_DUPLEX_STATE;

  Pndu_NDIS_SUPPORTED_PAUSE_FUNCTIONS = ^Tndu_NDIS_SUPPORTED_PAUSE_FUNCTIONS;
  Tndu_NDIS_SUPPORTED_PAUSE_FUNCTIONS = (
    NdisPauseFunctionsUnsupported,
    NdisPauseFunctionsSendOnly,
    NdisPauseFunctionsReceiveOnly,
    NdisPauseFunctionsSendAndReceive,
    NdisPauseFunctionsUnknown
    );

const
  NDU_NDIS_LINK_STATE_XMIT_LINK_SPEED_AUTO_NEGOTIATED = $00000001;
  NDU_NDIS_LINK_STATE_RCV_LINK_SPEED_AUTO_NEGOTIATED = $00000002;
  NDU_NDIS_LINK_STATE_DUPLEX_AUTO_NEGOTIATED = $00000004;
  NDU_NDIS_LINK_STATE_PAUSE_FUNCTIONS_AUTO_NEGOTIATED = $00000008;



  // structure used in NDIS_STATUS_LINK_STATE and OID_GEN_LINK_STATE


  NDU_NDIS_LINK_STATE_REVISION_1 = 1;

type
  Pndu_NDIS_LINK_STATE = ^Tndu_NDIS_LINK_STATE;

  Tndu_NDIS_LINK_STATE = record
    Header: Tndu_NDIS_OBJECT_HEADER;
    MediaConnectState: Tndu_NDIS_MEDIA_CONNECT_STATE;
    MediaDuplexState: Tndu_NDIS_MEDIA_DUPLEX_STATE;
    XmitLinkSpeed: ulong64;
    RcvLinkSpeed: ulong64;
    PauseFunctions: Tndu_NDIS_SUPPORTED_PAUSE_FUNCTIONS;
    AutoNegotiationFlags: ulong;
  end;


// the following structure is used in OID_GEN_LINK_PARAMETERS


const
  NDU_NDIS_LINK_PARAMETERS_REVISION_1 = 1;

type
  Pndu_NDIS_LINK_PARAMETERS = ^Tndu_NDIS_LINK_PARAMETERS;

  Tndu_NDIS_LINK_PARAMETERS = record
    Header: Tndu_NDIS_OBJECT_HEADER;
    MediaDuplexState: Tndu_NDIS_MEDIA_DUPLEX_STATE;
    XmitLinkSpeed: ulong64;
    RcvLinkSpeed: ulong64;
    PauseFunctions: Tndu_NDIS_SUPPORTED_PAUSE_FUNCTIONS;
    AutoNegotiationFlags: ulong;
  end;


// structure used in NDIS_STATUS_LINK_STATE and OID_GEN_LINK_STATE


const
  NDU_NDIS_OPER_STATE_REVISION_1 = 1;

type
  Pndu_NDIS_OPER_STATE = ^Tndu_NDIS_OPER_STATE;

  Tndu_NDIS_OPER_STATE = record
    Header: Tndu_NDIS_OBJECT_HEADER;
    OperationalStatus: Tndu_NET_IF_OPER_STATUS;
    OperationalStatusFlags: ulong;
  end;


// These defines and structures are used with
// OID_TCP_OFFLOAD_PARAMETERS


const
  NDU_NDIS_OFFLOAD_PARAMETERS_NO_CHANGE = 0;


  // values used in IPv4Checksum, TCPIPv4Checksum, UDPIPv4Checksum
  // TCPIPv6Checksum and UDPIPv6Checksum


  NDU_NDIS_OFFLOAD_PARAMETERS_TX_RX_DISABLED = 1;
  NDU_NDIS_OFFLOAD_PARAMETERS_TX_ENABLED_RX_DISABLED = 2;
  NDU_NDIS_OFFLOAD_PARAMETERS_RX_ENABLED_TX_DISABLED = 3;
  NDU_NDIS_OFFLOAD_PARAMETERS_TX_RX_ENABLED = 4;


  // values used in LsoV1


  NDU_NDIS_OFFLOAD_PARAMETERS_LSOV1_DISABLED = 1;
  NDU_NDIS_OFFLOAD_PARAMETERS_LSOV1_ENABLED = 2;


  // values used in IPsecV1


  NDU_NDIS_OFFLOAD_PARAMETERS_IPSECV1_DISABLED = 1;
  NDU_NDIS_OFFLOAD_PARAMETERS_IPSECV1_AH_ENABLED = 2;
  NDU_NDIS_OFFLOAD_PARAMETERS_IPSECV1_ESP_ENABLED = 3;
  NDU_NDIS_OFFLOAD_PARAMETERS_IPSECV1_AH_AND_ESP_ENABLED = 4;


  // values used in LsoV2


  NDU_NDIS_OFFLOAD_PARAMETERS_LSOV2_DISABLED = 1;
  NDU_NDIS_OFFLOAD_PARAMETERS_LSOV2_ENABLED = 2;


  // values used in TcpConnectionIPv4 and TcpConnectionIPv6 fields
  // of NDIS_OFFLOAD_PARAMETERS


  NDU_NDIS_OFFLOAD_PARAMETERS_CONNECTION_OFFLOAD_DISABLED = 1;
  NDU_NDIS_OFFLOAD_PARAMETERS_CONNECTION_OFFLOAD_ENABLED = 2;


  // Used in OID_TCP_OFFLOAD_PARAMETERS for setting
  // the offload parameters of a NIC


  NDU_NDIS_OFFLOAD_PARAMETERS_REVISION_1 = 1;

type
  Pndu_NDIS_OFFLOAD_PARAMETERS = ^Tndu_NDIS_OFFLOAD_PARAMETERS;

  Tndu_NDIS_OFFLOAD_PARAMETERS = record

    // Header.Type = NDIS_OBJECT_TYPE_DEFAULT;
    // Header.Revision = NDIS_OFFLOAD_PARAMETERS_REVISION_1;
    // Header.Size = sizeof(NDIS_OFFLOAD_PARAMETERS);


    Header: Tndu_NDIS_OBJECT_HEADER;

    IPv4Checksum: uchar;
    TCPIPv4Checksum: uchar;
    UDPIPv4Checksum: uchar;

    TCPIPv6Checksum: uchar;
    UDPIPv6Checksum: uchar;

    LsoV1: uchar;
    IPsecV1: uchar;

    LsoV2IPv4: uchar;
    LsoV2IPv6: uchar;

    TcpConnectionIPv4: uchar;
    TcpConnectionIPv6: uchar;

    Flags: ulong;
  end;

//#define NDIS_SIZEOF_OFFLOAD_PARAMETERS_REVISION_1 RTL_SIZEOF_THROUGH_FIELD(NDIS_OFFLOAD_PARAMETERS, Flags)

const
  NDU_NDIS_OFFLOAD_NOT_SUPPORTED = 0;
  NDU_NDIS_OFFLOAD_SUPPORTED = 1;

  NDU_NDIS_OFFLOAD_SET_NO_CHANGE = 0;
  NDU_NDIS_OFFLOAD_SET_ON = 1;
  NDU_NDIS_OFFLOAD_SET_OFF = 2;


  // Encapsulation types that are used during offload in query and set


  NDU_NDIS_ENCAPSULATION_NOT_SUPPORTED = $00000000;
  NDU_NDIS_ENCAPSULATION_NULL = $00000001;
  NDU_NDIS_ENCAPSULATION_IEEE_802_3 = $00000002;
  NDU_NDIS_ENCAPSULATION_IEEE_802_3_P_AND_Q = $00000004;
  NDU_NDIS_ENCAPSULATION_IEEE_802_3_P_AND_Q_IN_OOB = $00000008;
  NDU_NDIS_ENCAPSULATION_IEEE_LLC_SNAP_ROUTED = $00000010;

//#pragma warning(push)
//#pragma warning(disable:4214) //nonstandard extension used : bit field types other than int


// Describes the large send offload version 1 capabilities
// or configuration of the NIC. Used in NDIS_OFFLOAD structure

type
  Pndu_NDIS_TCP_LARGE_SEND_OFFLOAD_V1 = ^Tndu_NDIS_TCP_LARGE_SEND_OFFLOAD_V1;

  Tndu_NDIS_TCP_LARGE_SEND_OFFLOAD_V1 = record
    IPv4: record
      Encapsulation: ulong;
      MaxOffLoadSize: ulong;
      MinSegmentCount: ulong;
      TcpOptions: ulong;    //TcpOptions:2;
      IpOptions: ulong;      //IpOptions:2;
    end;
  end;


  // Describes the checksum task offload capabilities or configuration
  // of the NIC. used in NDIS_OFFLOAD structure

  Pndu_NDIS_TCP_IP_CHECKSUM_OFFLOAD = ^Tndu_NDIS_TCP_IP_CHECKSUM_OFFLOAD;

  Tndu_NDIS_TCP_IP_CHECKSUM_OFFLOAD = record
    IPv4Transmit: record
      Encapsulation: ulong;
      IpOptionsSupported: ulong;  // IpOptionsSupported:2;
      TcpOptionsSupported: ulong;  // TcpOptionsSupported:2;
      TcpChecksum: ulong;          // TcpChecksum:2;
      UdpChecksum: ulong;          // UdpChecksum:2;
      IpChecksum: ulong;          // IpChecksum:2;
    end;

    IPv4Receive: record
      Encapsulation: ulong;
      IpOptionsSupported: ulong;  // IpOptionsSupported:2;
      TcpOptionsSupported: ulong;  // TcpOptionsSupported:2;
      TcpChecksum: ulong;          // TcpChecksum:2;
      UdpChecksum: ulong;          // UdpChecksum:2;
      IpChecksum: ulong;          // IpChecksum:2;
    end;

    IPv6Transmit: record
      Encapsulation: ulong;
      IpExtensionHeadersSupported: ulong;    // IpExtensionHeadersSupported:2;
      TcpOptionsSupported: ulong;            // TcpOptionsSupported:2;
      TcpChecksum: ulong;                    // TcpChecksum:2;
      UdpChecksum: ulong;                    // UdpChecksum:2;
    end;

    IPv6Receive: record
      Encapsulation: ulong;
      IpExtensionHeadersSupported: ulong;    // IpExtensionHeadersSupported:2;
      TcpOptionsSupported: ulong;            // TcpOptionsSupported:2;
      TcpChecksum: ulong;                    // TcpChecksum:2;
      UdpChecksum: ulong;                    // UdpChecksum:2;
    end;
  end;


  // Describes the IPsec task offload version 1 capabilities
  // or configuration of the NIC. Used in NDIS_OFFLOAD structure

  Tndu_NDIS_IPSEC_OFFLOAD_V1 = record
    Supported: record

    end;
  end;

implementation

function NDIS_CONTROL_CODE(request, method: integer): integer;
begin
  Result := CTL_CODE(NDU_FILE_DEVICE_PHYSICAL_NETCARD, request,
    method, NDU_FILE_ANY_ACCESS);
end;

end.
