unit nduWinCred;

interface

uses
  nduCType, Windows;

const
  credui = 'credui.dll';

  CRED_MAX_USERNAME_LENGTH = (256 + 1 + 256);
  CRED_MAX_CREDENTIAL_BLOB_SIZE = 512;

  CREDUI_MAX_USERNAME_LENGTH = CRED_MAX_USERNAME_LENGTH;
  CREDUI_MAX_PASSWORD_LENGTH = (CRED_MAX_CREDENTIAL_BLOB_SIZE div 2);

  CREDUI_FLAGS_INCORRECT_PASSWORD = $00001;
  CREDUI_FLAGS_DO_NOT_PERSIST = $00002;
  CREDUI_FLAGS_REQUEST_ADMINISTRATOR = $00004;
  CREDUI_FLAGS_EXCLUDE_CERTIFICATES = $00008;
  CREDUI_FLAGS_REQUEST_CERTIFICATE = $00010;
  CREDUI_FLAGS_SHOW_SAVE_CHECK_BOX = $00040;
  CREDUI_FLAGS_ALWAYS_SHOW_UI = $00080;
  CREDUI_FLAGS_REQUIRE_SMARTCARD = $00100;
  CREDUI_FLAGS_PASSWORD_ONLY_OK = $00200;
  CREDUI_FLAGS_VALIDATE_USERNAME = $00400;
  CREDUI_FLAGS_COMPLETE_USERNAME = $00800;
  CREDUI_FLAGS_PERSIST = $01000;
  CREDUI_FLAGS_SERVER_CREDENTIAL = $04000;
  CREDUI_FLAGS_EXPECT_CONFIRMATION = $20000;
  CREDUI_FLAGS_GENERIC_CREDENTIALS = $40000;
  CREDUI_FLAGS_USERNAME_TARGET_CREDENTIALS = $80000;
  CREDUI_FLAGS_KEEP_USERNAME = $100000;

type
  PCtxtHandle = PSecHandle;

  PCREDUI_INFO = ^TCREDUI_INFO;

  TCREDUI_INFO = record
    cbSize: DWORD;
    hWnd: THandle;
    MessageText: PWideChar;
    CaptionText: PWideChar;
    Bitmap: HBITMAP;
  end;

function CredUICmdLinePromptForCredentials(pszTargetName: LPCTSTR;
  pContext: PCtxtHandle; dwAuthError: DWORD; UserName: PTSTR;
  ulUserBufferSize: ULONG; pszPassword: PTSTR; ulPasswordBufferSize: ULONG;
  pfSave: PBoolean; dwFlags: DWORD): DWORD; stdcall;

function CredUIPromptForCredentialsW(UIINFO: PCREDUI_INFO;
  TargetName: PWideChar; Reserved: THandle; AuthError: DWORD;
  Username: PWideChar; UserNameMaxChars: ULONG; Password: PWideChar;
  PasswordMaxChars: ULONG; var Save: BOOL; Flags: DWORD): DWORD; stdcall;

implementation

function CredUICmdLinePromptForCredentials;
  external credui Name 'CredUICmdLinePromptForCredentials';
function CredUIPromptForCredentialsW;
  external credui Name 'CredUIPromptForCredentialsW';

end.
