unit nduifdef;

interface

uses
  nduCType;

type
  Pndu_NET_IF_OPER_STATUS = ^Tndu_NET_IF_OPER_STATUS;
  Tndu_NET_IF_OPER_STATUS = (                         // ifOperStatus
    NET_IF_OPER_STATUS_UP = 1,
    NET_IF_OPER_STATUS_DOWN = 2,
    NET_IF_OPER_STATUS_TESTING = 3,
    NET_IF_OPER_STATUS_UNKNOWN = 4,
    NET_IF_OPER_STATUS_DORMANT = 5,
    NET_IF_OPER_STATUS_NOT_PRESENT = 6,
    NET_IF_OPER_STATUS_LOWER_LAYER_DOWN = 7
    );

  Pndu_NET_IF_MEDIA_CONNECT_STATE = ^Tndu_NET_IF_MEDIA_CONNECT_STATE;
  Tndu_NET_IF_MEDIA_CONNECT_STATE = (
    MediaConnectStateUnknown,
    MediaConnectStateConnected,
    MediaConnectStateDisconnected
    );


  // Defines the duplex state of media


  Pndu_NET_IF_MEDIA_DUPLEX_STATE = ^Tndu_NET_IF_MEDIA_DUPLEX_STATE;
  Tndu_NET_IF_MEDIA_DUPLEX_STATE = (
    MediaDuplexStateUnknown,
    MediaDuplexStateHalf,
    MediaDuplexStateFull
    );

const

  // maximum string size in -wchar- units


  NDU_IF_MAX_STRING_SIZE = 256;

type
  Pndu_IF_COUNTED_STRING_LH = ^Tndu_IF_COUNTED_STRING_LH;

  Tndu_IF_COUNTED_STRING_LH = record
    Length: ushort; // in -Bytes-
    aString: array[0..NDU_IF_MAX_STRING_SIZE] of wchar; // String
  end;

const
  NDU_IF_MAX_PHYS_ADDRESS_LENGTH = 32;

type
  Pndu_IF_PHYSICAL_ADDRESS_LH = ^Tndu_IF_PHYSICAL_ADDRESS_LH;

  Tndu_IF_PHYSICAL_ADDRESS_LH = record
    Length: ushort;
    Address: array[0..NDU_IF_MAX_PHYS_ADDRESS_LENGTH - 1] of uchar;
  end;

  Tndu_IF_PHYSICAL_ADDRESS = Tndu_IF_PHYSICAL_ADDRESS_LH;

implementation

end.
